-*- coding: utf-8 -*-

commit a777087be612b7675fe012560bf0d8fddff20f55
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-05-29 12:54:36 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-29 12:54:36 +0900

    Bump up 3.1.6

commit 7da01370d51e3a2e5c2c6092b2cc0da793176843
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-05-24 16:23:02 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-24 16:59:42 +0900

    Revert "[ruby/openssl] Use EVP_Digest{Sign,Verify} when available"

    This reverts commit 63f40a5be59ac898e87528630568b7890ffcf5fb.

commit dc969b3a9c8bc1c860ecfd9306b3a5872e36579a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-05-24 16:22:55 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-24 16:59:42 +0900

    Revert "[ruby/openssl] Enable HKDF support for LibreSSL 3.6 and later"

    This reverts commit b6da54c7219197eacdbfdca53739686f0bb2d06a.

commit b6da54c7219197eacdbfdca53739686f0bb2d06a
  Author:     Theo Buehler <tb@openbsd.org>
  AuthorDate: 2022-11-24 01:09:50 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-24 13:02:00 +0900

    [ruby/openssl] Enable HKDF support for LibreSSL 3.6 and later

    LibreSSL 3.6 added support for HKDF in EVP. Enable this in ossl_kdf.c.

    https://github.com/ruby/openssl/commit/9bdd39a7e2

commit 63f40a5be59ac898e87528630568b7890ffcf5fb
  Author:     Theo Buehler <tb@openbsd.org>
  AuthorDate: 2022-11-10 22:50:22 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-24 13:02:00 +0900

    [ruby/openssl] Use EVP_Digest{Sign,Verify} when available

    LibreSSL 3.4 added EVP_DigestSign() and EVP_DigestVerify(). Use them
    when available to prepare for the addition of Ed25519 support in
    LibreSSL 3.7.

    https://github.com/ruby/openssl/commit/475b2bf766

commit 5f641517689719fb9cf1aa76d2834644ad639010
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-05-24 12:05:24 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-24 13:02:00 +0900

    LibreSSL 3.5 and later provide and need to use PEM_write_bio_PrivateKey_traditional()

    Co-authored-by: "Jeremy Evans" <code@jeremyevans.net>

commit 0a671907355d806f1701ab5f677e1582f834a925
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-05-23 13:26:29 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-23 14:12:53 +0900

    merge revision(s) ae8990aef098410ecc2b5f48fea9d7d171a3c5f6:

            Alias init functions

            The extension library has each initialization function named "Init_" +
            basename. If multiple extensions have the same base name (such as
            cgi/escape and erb/escape), the same function will be registered for
            both names.

            To fix this conflict, rename the initialization functions under sub
            directories using using parent names, when statically linking.
            ---
             ext/extmk.rb            | 16 +++++++++++++++-
             template/extinit.c.tmpl |  2 +-
             2 files changed, 16 insertions(+), 2 deletions(-)

commit 60fb6d485944ea9dc07900a566cd5bd6ba5e083f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-05-23 12:49:30 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-23 13:24:36 +0900

    merge revision(s) 7f87ad9fc4bc45faf8cd33602a025f27c094b2fd:

            Refer autoconfigured endian macro (#10572)

            Remove the case `RB_IO_BUFFER_HOST_ENDIAN` is not defined.
            ---
             include/ruby/io/buffer.h | 8 ++------
             1 file changed, 2 insertions(+), 6 deletions(-)

commit c54f52fb4da10aae50a74badf85994e9264e1cc4
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-05-23 12:49:24 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-23 13:24:36 +0900

    merge revision(s) 1faeb44dfcf777ace28321e80d0ebf942161a0a7:

            Check if macros are defined before using

            Assume macros with the same prefix would be defined together.
            ---
             include/ruby/io/buffer.h | 8 ++++----
             1 file changed, 4 insertions(+), 4 deletions(-)

commit 7256dfd4a127abfd22c6ed0b6196666ec273e08f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-07-25 16:07:33 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-23 12:45:59 +0900

    [Bug #19751] Remove linemarkers in middle

commit c884de63c8c9833ee6a054b6363e23cfc2cbd74e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-05-23 11:19:52 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-23 11:58:26 +0900

    merge revision(s) 48644e71096c70132be9dfdcbfb414ec2e68d18b:

            tool/runruby.rb: remove LD_PRELOAD-like env-var options from
             runruby.rb

            LD_PRELOAD sometimes forces loading libraries into unrelated
            executables. For example, macOS on recent Apple Silicon can execute
            arm64 and arm64e binaries by default, and /usr/bin/clang is built as
            arm64e. If Ruby is built as arm64, and mkmf launched through runruby.rb
            spawns /usr/bin/clang, dynamic loader tries to load libruby (arm64e)
            into clang (arm64). This force-load causes library load failure.
            In theory, we don't need both LD_PRELOAD and LD_LIBRARY_PATH at the same
            time, because executables requiring libruby already have libruby
            dependency, so LD_LIBRARY_PATH is enough for this case.
            ---
             tool/runruby.rb | 9 ---------
             1 file changed, 9 deletions(-)

commit 5979e4118dfae7f68f12d25429183bdeccf889df
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-05-23 10:20:09 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-23 10:57:56 +0900

    macos-11 will be retired at Jun, 2024

commit 80b11b216d5ca9338b2384c0215bc652e826412d
  Author:     Sutou Kouhei <kou@clear-code.com>
  AuthorDate: 2022-09-15 07:08:20 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-23 10:57:56 +0900

    merge revision(s) a4ad6bd9aac564e93219284c912b26a72f9e82fc:

            [ruby/fiddle] closure: free resources when an exception is raised in
             Closure.new

            GitHub: GH-102

            https://github.com/ruby/fiddle/commit/81a8a56239
            ---
             ext/fiddle/closure.c | 56 ++++++++++++++++++++++++++++++++++++++++------------
             1 file changed, 43 insertions(+), 13 deletions(-)

commit 07c11226a058c61296ad75a9c266b5a0f159b600
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-05-21 13:29:34 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-21 14:06:43 +0900

    merge revision(s) cfc564ac40496a392f463658ea33954ea76d6b11:

            Include headers for `ruby_qsort` only if needed

            If GNU `qsort_r` is available, we use the function and these headers
            are not used.
            ---
             util.c | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

commit 24d7a1c6e73fa2d8e9f8996c16dcf2a31ce5c751
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-05-21 13:29:08 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-21 14:06:43 +0900

    merge revision(s) ed3d8f74ec2eee43d50f9826e2f11ceea279823e:

            Delete a macro that has never been used, probably added by mistake

            ---
             util.c | 7 -------
             1 file changed, 7 deletions(-)

commit 122b510b94f815473cc5cc1d47701a06a0bc44a0
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-05-21 13:25:08 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-21 14:06:43 +0900

    merge revision(s) 7400628cb054a9a9651d69411a100fc9d518099f:

            [Bug #18997] Don't define ruby_qsort when POSIX qsort_r is available

            The current code would define ruby_qsort as a wrapper of qsort_s
            when it is available. When both qsort_s and POSIX (GNU) qsort_r
            are available, we should call qsort_r directly instead, and
            the qsort_s wrapper is redundant.
            ---
             util.c | 6 ++++--
             1 file changed, 4 insertions(+), 2 deletions(-)

commit a131d2391f5a46d7cf7838e79ddfe4cf8018b365
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-05-17 11:52:12 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-17 17:25:59 +0900

    AppVeyor is retired at 2024

commit 5db59cd50f7164f462289952d59bf8eac3a018f6
  Author:     Jun Aruga <jaruga@redhat.com>
  AuthorDate: 2024-03-12 22:39:05 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-17 17:25:59 +0900

    [ruby/openssl] test_asn1.rb: Remove the assertions of the time string format without second.

    This commit fixes the following errors in the tests.
    Because the OpenSSL project changed the code to make the time string format
    without second invalid. So, we drop the assertions.

    ```
    1) Error: test_generalizedtime(OpenSSL::TestASN1): OpenSSL::ASN1::ASN1Error: generalizedtime is too short
    /home/runner/work/ruby-openssl/ruby-openssl/test/openssl/test_asn1.rb:698:in `decode'
    /home/runner/work/ruby-openssl/ruby-openssl/test/openssl/test_asn1.rb:698:in `decode_test'
    /home/runner/work/ruby-openssl/ruby-openssl/test/openssl/test_asn1.rb:433:in `test_generalizedtime'
         430:       OpenSSL::ASN1::GeneralizedTime.new(Time.utc(9999, 9, 8, 23, 43, 39))
         431:     # LibreSSL 3.6.0 requires the seconds element
         432:     return if libressl?
      => 433:     decode_test B(%w{ 18 0D }) + "201612081934Z".b,
         434:       OpenSSL::ASN1::GeneralizedTime.new(Time.utc(2016, 12, 8, 19, 34, 0))
         435:     # not implemented
         436:     # decode_test B(%w{ 18 13 }) + "https://github.com/ruby/openssl/commit/201612081934+0930".b,

    2) Error: test_utctime(OpenSSL::TestASN1): OpenSSL::ASN1::ASN1Error: utctime is too short
    /home/runner/work/ruby-openssl/ruby-openssl/test/openssl/test_asn1.rb:698:in `decode'
    /home/runner/work/ruby-openssl/ruby-openssl/test/openssl/test_asn1.rb:698:in `decode_test'
    /home/runner/work/ruby-openssl/ruby-openssl/test/openssl/test_asn1.rb:411:in `test_utctime'
         408:     end
         409:     # Seconds is omitted. LibreSSL 3.6.0 requires it
         410:     return if libressl?
      => 411:     decode_test B(%w{ 17 0B }) + "1609082343Z".b,
         412:       OpenSSL::ASN1::UTCTime.new(Time.utc(2016, 9, 8, 23, 43, 0))
         413:     # not implemented
         414:     # decode_test B(%w{ 17 11 }) + "https://github.com/ruby/openssl/commit/500908234339+0930".b,
    ```

    https://github.com/ruby/openssl/commit/2e826d5715

commit 89574f02e1abc58e4459d734424b430bcd4c6f17
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2022-10-17 16:50:01 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-17 17:25:59 +0900

    [ruby/openssl] test/openssl/test_asn1.rb: skip failing tests on LibreSSL 3.6.0

    LibreSSL 3.6.0 expects the seconds part in UTCTime and GeneralizedTime
    to be always present. LibreSSL 3.6.0 release note [1] says:

    > - The ASN.1 time parser has been refactored and rewritten using CBS.
    >   It has been made stricter in that it now enforces the rules from
    >   RFC 5280.

    [1] https://ftp.openbsd.org/pub/OpenBSD/LibreSSL/libressl-3.6.0-relnotes.txt

    https://github.com/ruby/openssl/commit/bbc540fe83

commit 10f4e4d936ece813ff3bc061a0ecff85804447cc
  Author:     Xi Ruoyao <xry111@xry111.site>
  AuthorDate: 2024-04-24 14:42:09 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-17 17:25:59 +0900

    [ruby/net-http] Skip test_session_reuse_but_expire with OpenSSL 3.3

    OpenSSL 3.3.0 9 Apr 2024 is also broken.

    Signed-off-by: Xi Ruoyao <xry111@xry111.site>

    https://github.com/ruby/net-http/commit/ab525c956d

commit 1945f8dc0ea71f536931364fa3605b7507807bb5
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-04-23 19:20:59 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-04-23 19:20:59 +0900

    Bump up 3.1.5

commit bfe9164a84878720ad484813eef0b75742e4cd8f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-04-23 19:20:20 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-04-23 19:20:20 +0900

    merge revision(s) 989a2355808a63fc45367785c82ffd46d18c900a:

            Fix Use-After-Free issue for Regexp

            Co-authored-by: Isaac Peka <7493006+isaac-peka@users.noreply.github.com>
            ---
             regexec.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 8f6656645132f7c3bdc84230ecc881ca67c5a7f5
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-04-23 19:19:57 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-04-23 19:19:57 +0900

    merge revision(s) 33e5b47c16f1fd3382186e6ffe73cfc6e00946f7:

            Fix handling of reg->dmin in Regex matching

            ---
             regexec.c | 10 ++++++++++
             1 file changed, 10 insertions(+)

commit 36b6490fb559617f627c70128faae1596f4c0f84
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-03-21 15:44:45 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-04-23 16:04:54 +0900

    Merge RDoc-6.4.1.1

commit 26ec606bcd2de68b457a9b36852b764a71083b25
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-03-21 15:56:32 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-04-23 16:04:41 +0900

    Merge StringIO 3.0.1.2

commit 74879c7d044359f02987042dad3f824c93c7b8d3
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-04-15 10:07:05 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-04-15 14:05:00 +0900

    We no longer use Cirrus CI

commit b0aff455ec4e30c3130377d09995559506f8d788
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-01-13 17:44:09 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-04-15 14:05:00 +0900

    [MSWin] Install libffi using vcpkg

commit 1fb8872b1563a4c7ff0d5acccb85f72a94189fca
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-04-12 16:20:14 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-04-15 14:05:00 +0900

    Skip c99 and c2x compilers because Ruby 3.1 couldn't build openssl gem with them.

    https://github.com/ruby/ruby/actions/runs/8657971535/job/23741841371?pr=10512
    https://github.com/ruby/ruby/actions/runs/8657971535/job/23741841091?pr=10512

commit e91755734a98d03513d758e4e82064c300f6b9a0
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-03-21 21:15:02 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-04-15 14:05:00 +0900

    merge revision(s) 64b6a018a38f200c957fdbbe7d0cbe0e64781c9f:

            Fix test session reuse but expire (#9824)

            * OpenSSL 3.2.1 30 Jan 2024 is also broken

            Import 45064610725ddd81a5ea3775da35aa46985bc789 from ruby_3_3 branch
            tentatively.
            ---
             test/net/http/test_https.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit cf8149ab94a04d95a26efe402729a57c21a78c4c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-04-12 15:25:06 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-04-15 14:05:00 +0900

    Try to fix https://github.com/ruby/ruby/actions/runs/8370868368/job/22918952425?pr=10321

    ruby_3_2 fixed that with https://github.com/ruby/ruby/commit/e777064e4b064fd77aca65c123f1919433f6732d

commit 2b608349bbd84dd01bffc92aaaced15ff5823bd6
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-11-26 01:18:48 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-01-11 17:59:14 +0900

    Omit test_session_reuse_but_expire if OpenSSL 3.2.0

commit 21a9b182e5fb08cf762d6e4dde9da641251cfc9a
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-11-25 14:43:29 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-01-11 17:59:14 +0900

    Omit a broken https test on MinGW

    This started to reliably fail on MinGW at an irrelevant commit:
    https://github.com/ruby/ruby/actions/runs/6981002841/job/18997302124
    https://github.com/ruby/ruby/actions/runs/6981946473/job/19000104223
    https://github.com/ruby/ruby/actions/runs/6983823136/job/19005613809
    https://github.com/ruby/ruby/actions/runs/6983912116/job/19005844596
    https://github.com/ruby/ruby/actions/runs/6984215921/job/19006649495
    https://github.com/ruby/ruby/actions/runs/6984383103/job/19007100446
    https://github.com/ruby/ruby/actions/runs/6986489509/job/19012000642

    So this failure is not detecting a new bug. Let's skip this until we fix
    this test for MinGW.

commit 3ed6ddb8655a4e795eb6ee668c71351b387a9f1f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-10-15 23:55:25 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-01-11 17:03:51 +0900

    No longer download zlib source

    Although zlib package in vcpkg is still 1.2.12, it should be no
    problem in ruby tests.

commit 4e7b2fb3bb1d1a9cd833e611607484bc94188e11
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-01-05 17:37:56 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-01-11 17:03:51 +0900

    Bump up net-http to 0.3.0.1

commit db2f0a75e35130be99b012ce36ed430899be9ac5
  Author:     Sorah Fukumori <her@sorah.jp>
  AuthorDate: 2024-01-01 20:45:54 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-01-11 17:03:51 +0900

    [ruby/net-http] Renew test certificates

    The private key is replaced with a public known test key published at
    [RFC 9500].

    Also lifetime has been extended to 10 years from 4 years.

    [RFC 9500]: https://www.rfc-editor.org/rfc/rfc9500.html

    https://github.com/ruby/net-http/commit/4ab6c4a500

commit 452691a1abe98c744aeec312166ea95e5d876cac
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-01-05 17:09:38 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-01-11 17:03:51 +0900

    Bump up net-imap to 0.2.4

commit 88ab2e3bbc82812679065a6eaf08b60859e62be6
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-01-05 16:50:57 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-01-11 17:03:51 +0900

    Bump up net-smtp to 0.3.1.1

commit 5f56a163aea49f9736e61e6c601ecfbfc1c80d30
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-01-05 14:41:04 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-01-11 17:03:51 +0900

    Bump up net-ftp to 0.1.4

commit 0a70dde90ab2b52191f4782d0ec7d0a99ab1e845
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-12-03 18:59:17 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-12-03 18:59:17 +0900

    Fix patch mistake

commit 902cbd05b6f2a306f003a2329db20c3e08f86992
  Author:     MSP-Greg <Greg.mpls@gmail.com>
  AuthorDate: 2023-12-03 18:53:28 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-12-03 18:53:28 +0900

    [CI] windows.yml - use MSYS2 bison instead of Chocolatey

commit 1cae5e7ceaca7304108fdec35d4858a9e4ff7fe0
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-11-20 21:11:21 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-11-20 21:11:21 +0900

    merge revision(s) 9eac9d71786a8dbec520d0541a91149f01adf8ea: [Backport #19969]

            [Bug #19969] Compact st_table after deleted if possible

            ---
             hash.c                 | 19 +++++++++++++++++++
             st.c                   | 40 +++++++++++++++++++++++++++++-----------
             test/ruby/test_hash.rb |  9 +++++++++
             3 files changed, 57 insertions(+), 11 deletions(-)

commit 031d05ccf2a45363143cae9d06fba0a09c8e2ef2
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-11-14 18:27:07 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-11-14 18:27:07 +0900

    Lock gem versions for C ext dependencies (#8918)

    * Lock rubocop and standard versions for json dependencies

      https://github.com/ruby/actions/actions/runs/6854220854/job/18636881910

      current directory: /home/runner/work/actions/actions/snapshot-ruby_3_1/tmp/7/gems/rubocop/ruby/3.1.0/gems/json-2.6.1/ext/json/ext/generator
      /usr/local/bin/ruby -I /home/runner/work/actions/actions/snapshot-ruby_3_1/lib extconf.rb
      extconf failed No such file or directory - /usr/local/bin/ruby

    * Lock parser version to remove racc dependency

commit 22e1d54f5bc71af4836c6724e817dee9abf35256
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-11-11 04:42:12 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-11-11 04:42:12 +0900

    Use bundler-2.3.27 for Ruby 3.1 (#8895)

    Use bundler-2.3.27

commit c39b19c5f0b93f23623a3078b699f21935be408a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-11-10 16:56:05 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-11-10 16:56:05 +0900

    Merge RubyGems-3.3.27 and Bundler-2.3.27 (#8889)

commit 42325aa826dada78d95b559fc50aaf4444edfbb0
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-07-30 15:13:58 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-11-07 15:30:35 +0900

    Ease the `Encoding::CompatibilityError` test failure

    At the time this test first started using `assert_raise_with_message`,
    it did not touch `Encoding.default_internal`.

commit 881088e06f092d20a361c9528b2927cdc2b1616c
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-11-06 20:22:27 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-11-06 20:22:27 +0900

    merge revision(s) 4329554f171fdb483cafa672df5f2a08741940c5: [Backport #19985]

            [Bug #19985] Raise LoadError with the converted feature name

            `Kernel#require` converts feature name objects that have the `to_path`
            method such as `Pathname`, but had used the original object on error
            and had resulted in an unexpected `TypeError`.
            ---
             load.c                    | 14 +++++++++++---
             test/ruby/test_require.rb | 26 +++++++++++++++++++++-----
             2 files changed, 32 insertions(+), 8 deletions(-)

commit 4f7b595815bd75706c276b03c8d445748e869f2e
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-11-06 20:18:14 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-11-06 20:18:14 +0900

    merge revision(s) 19346c2336053b351673da030b00c704138252d8: [Backport #19754]

            [Bug #19754] Make `IO::Buffer#get_string` check `offset` range
             (#8016)

            ---
             io_buffer.c                 | 3 +++
             test/ruby/test_io_buffer.rb | 8 ++++++++
             2 files changed, 11 insertions(+)

commit d494cf4ddababb80660381e963f910ccacc3f7bc
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-11-06 20:14:41 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-11-06 20:14:41 +0900

    merge revision(s) 4a7d6c2852aa734506be83c932168e8f974687b5: [Backport #18991]

            Fix false LocalJumpError when branch coverage is enabled

            `throw TAG_BREAK` instruction makes a jump only if the continuation of
            catch of TAG_BREAK exactly matches the instruction immediately following
            the "send" instruction that is currently being executed. Otherwise, it
            seems to determine break from proc-closure.

            Branch coverage may insert some recording instructions after "send"
            instruction, which broke the conditions for TAG_BREAK to work properly.

            This change forces to set the continuation of catch of TAG_BREAK
            immediately after "send" (or "invokesuper") instruction.

            [Bug #18991]
            ---
             compile.c                      | 25 ++++++++++++++++++++++++-
             test/coverage/test_coverage.rb | 14 ++++++++++++++
             2 files changed, 38 insertions(+), 1 deletion(-)

commit 992f3956d304b608912ed112889ec2ef8224e2be
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-10-30 15:25:15 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-10-30 15:25:15 +0900

     Relax matching pattern for rake version for Ruby 3.1 (https://github.com/rubygems/rubygems/pull/8798)

    [rubygems/rubygems] Relax matching pattern for rake version

    https://github.com/rubygems/rubygems/commit/a89f74c27e

commit 8563a144fda2fd130b672541a84d8bad0b6c4cd2
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-10-17 20:51:50 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-10-17 20:51:50 +0900

    merge revision(s) bcb3247072e6973d0f6b50ca5fed238d5824bd28,fe0225ff4d5af8b1f54009727b39d0d9b821eea3: [Backport #19778]

            [Bug #19778] Pass additional include options to INCFLAGS in common.mk

            ---
             common.mk            | 2 +-
             configure.ac         | 1 +
             template/Makefile.in | 1 +
             3 files changed, 3 insertions(+), 1 deletion(-)

            [Bug #19778] Add `-I` options for opt-dir to `$INCFLAGS`

            These options have been separated from `$CFLAGS` already in the
            other places.
            ---
             configure.ac | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit a3e1444663005d3440b56c3a8e1b88bb28935912
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-10-17 20:30:28 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-10-17 20:30:28 +0900

    merge revision(s) 96c5a4be7b0d72502001734770af0f4a735c544c: [Backport #19894]

        Fix memory leak in complemented method entries

        [Bug #19894]

        When a copy of a complemented method entry is created, there are two
        issues:

        1. IMEMO_FL_USER3 is not copied, so the complemented status is not
           copied over.
        2. In rb_method_entry_clone we increment both alias_count and
           complemented_count. However, when we free the method entry in
           rb_method_definition_release, we only decrement one of the two
           counters, resulting in the rb_method_definition_t being leaked.

        Co-authored-by: Adam Hess <adamhess1991@gmail.com>
        ---
         method.h                 |  5 +++--
         test/ruby/test_module.rb | 29 +++++++++++++++++++++++++++++
         vm_method.c              |  8 +++++---
         3 files changed, 37 insertions(+), 5 deletions(-)

commit 84f2aabd272a54e79979795d2d405090704a1d07
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-10-10 20:52:53 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-10-10 20:52:53 +0900

    merge revision(s) ada9f8a9f78b3ccd8a5187775d06f45eb9f636f5: [Backport #18914]

            [ruby/fiddle] closure: follow variable name change

            GitHub: GH-102

            https://github.com/ruby/fiddle/commit/2530496602
            ---
             ext/fiddle/closure.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit e031eff34387f300be27c24a725ddaa17f18f7e3
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-09-13 23:59:44 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-10-10 20:28:51 +0900

    Fix missing write barrier in iseq instruction list

    [Bug #19880]

    There's a missing write barrier for operands in the iseq instruction
    list, which can cause crashes.

    It can be reproduced when Ruby is compiled with `-DRUBY_DEBUG_ENV=1`.
    Using the following command:

    ```
    RUBY_GC_HEAP_OLDOBJECT_LIMIT_FACTOR=0 RUBY_DEBUG=gc_stress ruby -w --disable=gems -Itool/lib -W0 test.rb
    ```

    The following script crashes:

    ```
    require "test/unit"
    ```

commit 92d155ce4a69ad9d8ff9667121d510758f763437
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-10-10 20:09:14 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-10-10 20:09:14 +0900

    Should not do `brew upgrade`
    See 1b0da1e6236ad9a380abfe4ca8b51f06c34bb6f9

commit eb54ed809f61fb25a0de101a7a6a649e8d4a434c
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-10-10 20:02:12 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-10-10 20:02:12 +0900

    merge revision(s) a28c5151f567cada0d2f5c0c3ec4df7f97b80784: [Backport #19855]

            Fix Array#bsearch when block returns a non-integer numeric value

            ---
             array.c                 | 4 ++--
             test/ruby/test_array.rb | 4 ++++
             2 files changed, 6 insertions(+), 2 deletions(-)

commit 4153e807c55ec0fc234969ae08a01c1e0c8ed167
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-09-19 20:24:27 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-09-19 20:24:27 +0900

    Fix an ommission of previous fix

commit 8a8d889ca2ba1ace8784e49e02a6616dd5765d9e
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-09-05 20:47:58 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-09-05 20:48:57 +0900

    merge revision(s) 1f115f141dd17f75049a5e17107906c5bcc372e1: [Backport #19246]

            Speed up rebuilding the loaded feature index

            Rebuilding the loaded feature index slowed down with the bug fix
            for #17885 in 79a4484a072e9769b603e7b4fbdb15b1d7eccb15.  The
            slowdown was extreme if realpath emulation was used, but even when
            not emulated, it could be about 10x slower.

            This adds loaded_features_realpath_map to rb_vm_struct. This is a
            hidden hash mapping loaded feature paths to realpaths. When
            rebuilding the loaded feature index, look at this hash to get
            cached realpath values, and skip calling rb_check_realpath if a
            cached value is found.

            Fixes [Bug #19246]
            ---
             load.c    | 27 +++++++++++++++++++++++----
             vm.c      |  2 ++
             vm_core.h |  1 +
             3 files changed, 26 insertions(+), 4 deletions(-)

commit e88ffb885af222332826d46565ca405f4523ed8f
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-09-05 20:18:23 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-09-05 20:48:57 +0900

    merge revision(s) 382678d4112f4afc6272244c22924d2b004274b1: [Backport #19788]

            [Bug #19788] Use the result of `tCOLON2` event

            ---
             parse.y                            | 16 ++++++++--------
             test/ripper/test_parser_events.rb  | 17 +++++++++++++++++
             test/ripper/test_scanner_events.rb |  5 +++++
             3 files changed, 30 insertions(+), 8 deletions(-)

commit c08fdc68383ee368c18e15e298502e6ee0089e18
  Author:     KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au>
  AuthorDate: 2023-08-18 22:19:21 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-09-05 20:19:55 +0900

    Allow waitpid(-1) to be woken if a waitpid(pid) call is pending

    If two threads are running, with one calling waitpid(-1), and another
    calling waitpid($some_pid), and then $some_other_pid exits, we would
    expect the waitpid(-1) call to retrieve that exit status; however, it
    cannot actually do so until $some_pid _also_ exits.

    This patch fixes the issue by unconditionally checking for pending
    process group waits on SIGCHLD, and then allowing pending pid-only waits
    to "steal" the notification.

    [Fixes #19387]

commit bbbf150e4d20bd618c4b9e702a60638b045317d8
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-07-26 11:02:57 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-07-26 11:02:57 +0900

    Revert "merge revision(s) 91c004885fc75a93cadf0094fa86ec3bd0ec25f5: [Backport #19025]"

    This reverts commit e55dde3bdddbc595be12e7184a23e729647eb989.

commit e55dde3bdddbc595be12e7184a23e729647eb989
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-07-25 20:53:43 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-07-25 20:53:43 +0900

    merge revision(s) 91c004885fc75a93cadf0094fa86ec3bd0ec25f5: [Backport #19025]

            [Bug #19025] Numbered parameter names are always local variables

            ---
             parse.y                  | 2 +-
             test/ruby/test_syntax.rb | 1 +
             2 files changed, 2 insertions(+), 1 deletion(-)

commit aac3232ab09f649c5de86a1ef7b942de3cc218ce
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-07-25 20:37:25 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-07-25 20:37:40 +0900

    merge revision(s) fac814c2dc31afef272b45392a7389ef0bfa3a4f: [Backport #19602]

            Fix `PLATFORM_GET_INC`

            On platforms where unaligned word access is not allowed, and if
            `sizeof(val)` and `sizeof(type)` differ:

            - `val` > `type`, `val` will be a garbage.
            - `val` < `type`, outside `val` will be clobbered.
            ---
             regexec.c | 2 +-
             regint.h  | 9 ++++++++-
             2 files changed, 9 insertions(+), 2 deletions(-)

    note: ruby_3_1 is patched regint.h only

commit 3799270ec27b1267cd9923dae00bcb3955f7e061
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-07-25 20:29:45 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-07-25 20:29:45 +0900

    merge revision(s) bd786e78969f9d4a8699376ceafe10934b6ad533: [Backport #19084]

            Fix mutation on shared strings. (#7837)

            ---
             io_buffer.c                 | 19 ++++++++++++-------
             test/ruby/test_io_buffer.rb |  4 ----
             2 files changed, 12 insertions(+), 11 deletions(-)

commit e7c94d9d1d2bdbf396c489d1dc653c771f59bb92
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-07-25 20:18:30 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-07-25 20:18:30 +0900

    merge revision(s) 09295ea796900fb7b05d29e93364090e21598566: [Backport #19543]

            IO::Buffer#resize: Free internal buffer if new size is zero (#7569)

            `#resize(0)` on an IO::Buffer with internal buffer allocated will
            result in calling `realloc(data->base, 0)`. The behavior of `realloc`
            with size = 0 is implementation-defined (glibc frees the object
            and returns NULL, while BSDs return an inaccessible object). And
            thus such usage is deprecated in standard C (upcoming C23 will make it
            UB).

            To avoid this problem, just `free`s the memory when the new size is zero.
            ---
             io_buffer.c                 |  5 +++++
             test/ruby/test_io_buffer.rb | 18 ++++++++++++++++++
             2 files changed, 23 insertions(+)

commit cba152ff1f69fad98f4c67747dcf763407cd1883
  Author:     Eileen M. Uchitelle <eileencodes@users.noreply.github.com>
  AuthorDate: 2023-07-25 20:05:27 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-07-25 20:05:27 +0900

    Backport cvar clone bug fix for 19379 to 3.1 (#7889)

    * Copy cvar table on clone

    When a class with a class variable is cloned we need to also copy the
    cvar cache table from the original table to the clone. I found this bug
    while working on fixing [Bug #19379]. While this does not fix that bug
    directly it is still a required change to fix another bug revealed by
    the fix in https://github.com/ruby/ruby/pull/7265

    This needs to be backported to 3.2.x and 3.1.x.

    Co-authored-by: Aaron Patterson <tenderlove@ruby-lang.org>

    * Fix cvar caching when class is cloned

    The class variable cache that was added in
    https://github.com/ruby/ruby/pull/4544 changed the behavior of class
    variables on cloned classes. As reported when a class is cloned AND a
    class variable was set, and the class variable was read from the
    original class, reading a class variable from the cloned class would
    return the value from the original class.

    This was happening because the IC (inline cache) is stored on the ISEQ
    which is shared between the original and cloned class, therefore they
    share the cache too.

    To fix this we are now storing the `cref` in the cache so that we can
    check if it's equal to the current `cref`. If it's different we don't
    want to read from the cache. If it's the same we do. Cloned classes
    don't share the same cref with their original class.

    This will need to be backported to 3.1 in addition to 3.2 since the bug
    exists in both versions.

    We also added a marking function which was missing.

    Fixes [Bug #19379]

    Co-authored-by: Aaron Patterson <tenderlove@ruby-lang.org>

    * Add missing write barrier

    We were missing the write barrier for class_value to cref. This should
    fix the segv we were seeing in http://ci.rvm.jp/logfiles/brlog.trunk-gc-asserts.20230601-165052

    Co-authored-by: Aaron Patterson <tenderlove@ruby-lang.org>

    ---------

    Co-authored-by: Aaron Patterson <tenderlove@ruby-lang.org>

commit 7e926c4d8c2e785d174161b38a8a688b19ea4b99
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-07-25 20:00:21 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-07-25 20:00:21 +0900

    String#slice! should clear the coderange when truncating

    [Bug #19739]

    This bug was incidentally fixed in Ruby 3.2 via b0b9f72
    but remains on 3.1 and older.

    this patch is written by byroot, https://github.com/Shopify/ruby/commit/3b351ee62d4206bb72301c2e98dcb173f1e35be7

    Co-authored-by: Jean Boussier <byroot@ruby-lang.org>

commit 2698b68ae86df333ff8bc8c4655f8012ee619257
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-07-18 21:10:12 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-07-18 21:10:12 +0900

    merge revision(s) 537183cd2ac0163851277b46a2f21ea5914c11c0: [Backport #19577]

            Fix write barrier order for `klass` to `cme` edge

            Previously, the following crashes with
            `CFLAGS=-DRGENGC_CHECK_MODE=2 -DRUBY_DEBUG=1 -fno-inline`:

                $ ./miniruby -e 'GC.stress = true; Marshal.dump({})'

            It crashes with a write barrier (WB) miss assertion on an edge from the
            `Hash` class object to a newly allocated negative method entry.

            This is due to usages of vm_ccs_create() running the WB too early,
            before the method entry is inserted into the cc table, so before the
            reference edge is established. The insertion can trigger GC and promote
            the class object, so running the WB after the insertion is necessary.
            Move the insertion into vm_ccs_create() and run the WB after the
            insertion.

            Discovered on CI:
            http://ci.rvm.jp/results/trunk-asserts@ruby-sp2-docker/4391770
            ---
             vm_eval.c       |  3 +--
             vm_insnhelper.c | 10 ++++++----
             vm_method.c     |  3 +--
             3 files changed, 8 insertions(+), 8 deletions(-)

commit 3eea678b069aeec7f3a97437be204f65d5193e00
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-07-18 21:04:42 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-07-18 21:04:42 +0900

    merge revision(s) 52e571fa72debcd764765775bd1b76ee87e36d2d: [Backport #19580]

            Ensure ruby_xfree won't segfault if called after vm_destruct

            [Bug #19580]

            The real-world scenario motivating this change is libxml2's pthread
            code which uses `pthread_key_create` to set up a destructor that is
            called at thread exit to free thread-local storage.

            There is a small window of time -- after ruby_vm_destruct but before
            the process exits -- in which a pthread may exit and the destructor is
            called, leading to a segfault.

            Please note that this window of time may be relatively large if
            `atexit` is being used.
            ---
             gc.c | 12 ++++++++++--
             1 file changed, 10 insertions(+), 2 deletions(-)

commit c96ef4eee6b27796bb15ba161ef936998acbcf96
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-07-18 20:50:08 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-07-18 20:50:08 +0900

    merge revision(s) 02a7e12b80823919fb614ad3ea6241d5115d14fe: [Backport #19593]

            Ensure throw data is not set as cause

            [Bug #19593]

            rb_ec_setup_exception did not check if errinfo is a throw_data. This can
            cause crashes in code since it is assumed that id_cause is an object.

            We saw a crash in show_cause due to id_cause of errinfo being a
            throw_data. It crashes on rb_obj_is_kind_of since it cannot be called on
            T_IMEMO objects.

            Unfortunately, we couldn't find a reproduction script, however we
            debugged the core dump and rb_ec_setup_exception is the only place where
            id_cause is assigned from errinfo without checking if it is a
            throw_data.

            ```
            0x0000556c5708e6dd in sigsegv (sig=11, info=0x7f301befa3f0, ctx=0x7f301befa2c0) at signal.c:964
            0x00007f301d046420 in <signal handler called> () at /lib/x86_64-linux-gnu/libpthread.so.0
            class_search_class_ancestor (c=139844586301760, cl=<optimized out>) at object.c:810
            rb_obj_is_kind_of (obj=obj@entry=139839221734880, c=139844586301760) at object.c:861
            0x0000556c56f2f00f in show_cause
                (errinfo=errinfo@entry=139838840645160, str=str@entry=139839221730520, opt=139839221730480, highlight=0, reverse=reverse@entry=0, backtrace_limit=backtrace_limit@entry=-1, shown_causes=0x7ffe9d1a2d68) at ./include/ruby/internal/special_consts.h:175
            ```

            Co-Authored-By: Jean Boussier <byroot@ruby-lang.org>
            ---
             eval.c | 4 ++++
             1 file changed, 4 insertions(+)

commit 5fbc1d45f17e4bff7cc61a78a7d788aa32ff390a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-06-29 22:24:35 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-06-29 22:24:35 +0900

    CVE-2023-36617 for Ruby 3.1 (#7996)

    * Bump up v0.12.2

    * Merge URI-0.10.3 for Bundler

commit c87bf4d8e96819010942a00372ee518e22c76bac
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-06-26 20:09:45 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-06-26 20:09:45 +0900

    merge revision(s) 038f9ade3c4d965415e4956561975454cf9eeb21: [Backport #19585]

            Use tools appropriate with CC

            To get rid of mysterious errors such as:

            ```
            /Applications/Xcode.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/bin/nm: error: libruby.3.3-static.a(/): The end of the file was unexpectedly encountered
            ```

            and

            ```
            ld: warning: ignoring file ../../libruby.3.3-static.a, building for macOS-x86_64 but attempting to link with file built for macOS-x86_64
            Undefined symbols for architecture x86_64:
              "_rb_rational_num", referenced from:
            ```
            ---
             configure.ac | 6 ++++++
             1 file changed, 6 insertions(+)

commit 0275614ba213dfb6f05743a16f65623bc3b6e274
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-06-26 20:07:43 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-06-26 20:07:43 +0900

    merge revision(s) 2c8f287: [Backport #19532]

            Fix handling of 6-byte codepoints in left_adjust_char_head in CESU-8
             encoding

            ---
             enc/cesu_8.c                | 23 +++++++++++++++++++----
             test/ruby/enc/test_cesu8.rb |  4 ++++
             2 files changed, 23 insertions(+), 4 deletions(-)

commit 504f37af3d36c438a1b7604b10b12f56dfb66d8e
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-06-20 10:48:40 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-06-20 10:48:40 +0900

    more fix

commit 48b00c4d63db9d8361e6dd8d322bd253077e1d6a
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-06-20 10:32:50 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-06-20 10:32:50 +0900

    Fix previous commit

commit 6302bf2ebe8d4807ede5ac9b8602c92ed336e5bd
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-06-19 20:49:09 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-06-19 20:49:09 +0900

    merge revision(s) d2520b7b76759118071a16e6bca22726a5de9fb4: [Backport #19439]

            Marshal.load: restore instance variables on Regexp

            [Bug #19439]

            The instance variables were restore on the Regexp source,
            not the regexp itself.

            Unfortunately we have a bit of a chicken and egg problem.

            The source holds the encoding, and the encoding need to be set on
            the source to be able to instantiate the Regexp.

            So the instance variables have to be read on the `source`.
            To correct this we transfert the instance variables after
            instantiating the Regexp.

            The only way to avoid this would be to read the instance variable
            twice and rewind.
            ---
             marshal.c                             | 20 ++++++++++++++++++--
             spec/ruby/core/marshal/shared/load.rb | 11 +++++++++++
             2 files changed, 29 insertions(+), 2 deletions(-)

commit 344249674f7a7835445a44695664897fa4b83f00
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-06-19 20:21:40 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-06-19 20:21:40 +0900

    merge revision(s) 1cdf8ab07b24ebd16e93621957196e8b1d67f2ba: [Backport #19323]

            [Bug #19323] Raise `RangeError` instead of integer overflow

            ---
             bignum.c                  |  5 ++++-
             test/ruby/test_integer.rb | 18 ++++++++----------
             2 files changed, 12 insertions(+), 11 deletions(-)

commit f6491773986ac77f728a42251edb7bfd33eedbf8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-06-16 02:35:42 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-06-16 02:35:42 +0900

    Fix test-bundled-gems for Ruby 3.1 (#7935)

    * pry is not needed for test-bundled-gems

    * Run test-unit test without rake task to avoid yard dependency

    * Try to skip Prime_test.rb

commit 66d626fdb5b91459d4cc191f767d0d61d056bd83
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2023-05-08 12:09:07 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-05-08 12:09:07 +0900

    Skip drb tests on mswin (#7789)

    * Skip TestDRbSSLAry on mswin

    This doesn't seem to stably work on mswin:
    https://github.com/ruby/ruby/actions/runs/3505363753/jobs/5871633211

    For CI stability, it generally seems like a bad idea to run druby tests
    on Windows, given that it's pretty much unstable on MinGW as well.

    * Do not run drb SSL tests on Windows

    These tests often cause a timeout and this issue seems specific to the
    Windows platforms.
    https://github.com/ruby/ruby/actions/runs/3603761925/jobs/6072346738

    ---------

    Co-authored-by: Takashi Kokubun <takashikkbn@gmail.com>

commit 664433fe61d0c80d04e8db30709af44af3266597
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2023-05-05 23:07:23 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-05-05 23:07:23 +0900

    Use vcpkg instead of chocolatey for openssl (#7788)

commit 957bb7cb81995f26c671afce0ee50a5c660e540e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-03-29 13:28:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-30 19:53:51 +0900

    Merge Time-0.2.2

commit 535426828fe57e041d1f07dd317905f0efd12712
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-30 18:19:33 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-30 18:19:33 +0900

    bump patchlevel

commit 66ad6e533e968cb6a8f54674b1c3a3fd0a316893
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-03-28 18:00:13 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-29 15:27:07 +0900

    Added assert_linear_performance for URI tests

commit 8db69f684b425bf65be3ac13a3d415be0e5dc5df
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-03-28 16:56:56 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-29 15:27:07 +0900

    Merge URI-0.10.2 for bundler

commit 8ce4ab146498879b65e22f1be951b25eebb79300
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-03-28 16:50:53 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-29 15:27:07 +0900

    Merge URI-0.12.1

commit d9d95540e0f4a580b9bc58afac229162138926e6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-27 20:20:28 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-27 20:20:28 +0900

    merge revision(s) 2f916812a9b818b432ee7c299e021ec62d4727fb,ac458f6bc3c520c9f23364c85bfb033acda907a6:

            Skip test_europe_lisbon on macOS

            until we figure out why it's failing.
            ---
             test/ruby/test_time_tz.rb | 1 +
             1 file changed, 1 insertion(+)

            Historical timezones of Lisbon in tzdata are unstable

            ---
             test/ruby/test_time_tz.rb | 3 +--
             1 file changed, 1 insertion(+), 2 deletions(-)

commit da27583cf364c0d69c085db4abf358c334a8eca1
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-02-07 16:22:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-26 14:22:38 +0900

    Merge URI-0.12.0

commit 19af12ff195aba64bdca7a83f564f2c0e46061c0
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-26 13:12:36 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-26 13:12:36 +0900

    merge revision(s) e7342e76dfd26237c604e42f9a59a1eaa578c94e: [Backport #19485]

            [Bug #19485] [DOC] Mention tabs in indentation of heredoc identifier

            Co-Authored-By: sawa (Tsuyoshi Sawada) <sawadatsuyoshi@gmail.com>
            ---
             doc/syntax/literals.rdoc | 6 ++++++
             1 file changed, 6 insertions(+)

commit e66b7917d79d87121d9ee7b3d3048319e9faefb8
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-25 16:06:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-25 16:06:44 +0900

    merge revision(s) 195e32977f181c8af9233a12cfc2c98e0f7957f6:

            Skip test_udp_server on s390x RHEL 7.1

            It seems like it never succeeds on this CI.
            ---
             test/socket/test_socket.rb | 4 ++++
             1 file changed, 4 insertions(+)

commit c8ca169d68519f6193ddd98960d5e1e699c74ad2
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-25 16:04:53 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-25 16:04:53 +0900

    merge revision(s) 8d1109c03bacc952b6218af2e4ae9b74c9855273:

            Added assertion values for Amazon Linux 2023

            ---
             spec/ruby/core/file/utime_spec.rb | 8 +++++---
             1 file changed, 5 insertions(+), 3 deletions(-)

commit cd4a997e53a02e5a8b24e38a10ba5525c176980e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-25 15:03:14 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-25 15:03:14 +0900

    merge revision(s) 548086b34e3dd125edabf5dc1e46b891fad3ea9c,3dc8cde70078ccb38f5f4b0818ad5eecded01bd5,e0cf80d666d4b5df3229f030a16d10d21323508e: [Backport #19529]

            ObjectSpace::WeakMap: fix compaction support

            [Bug #19529]

            `rb_gc_update_tbl_refs` can't be used on `w->obj2wmap` because it's
            not a `VALUE -> VALUE` table, but a `VALUE -> VALUE *` table, so
            we need some dedicated iterator.
            ---
             test/ruby/test_weakmap.rb |  8 ++++++++
             weakmap.c                 | 37 ++++++++++++++++++++++++++++++++++++-
             2 files changed, 44 insertions(+), 1 deletion(-)

            Fix crash during compaction

            [Bug #19529]

            The fix for [Bug #19529] in commit 548086b contained a bug that crashes
            on the following script:

            ```
            wm = ObjectSpace::WeakMap.new
            obj = Object.new
            100.times do
              wm[Object.new] = obj
              GC.start
            end
            GC.compact
            ```
            ---
             test/ruby/test_weakmap.rb | 10 ++++++++++
             weakmap.c                 |  2 +-
             2 files changed, 11 insertions(+), 1 deletion(-)

            Fix incorrect size of WeakMap buffer

            In wmap_final_func, j is the number of elements + 1 (since j also
            includes the length at the 0th index), so we should resize the buffer
            to size j and the new length is j - 1.
            ---
             weakmap.c | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

commit bdbe6053853c11ffe9b8737eb4da50ed84c9dbd6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-25 14:35:55 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-25 14:35:55 +0900

    merge revision(s) 7bd7aee02e303de27d2cddfc5ef47e612d6782cb: [Backport #18464]

            Fix interpreter crash caused by RUBY_INTERNAL_EVENT_NEWOBJ + Ractors

            When a Ractor is created whilst a tracepoint for
            RUBY_INTERNAL_EVENT_NEWOBJ is active, the interpreter crashes. This is
            because during the early setup of the Ractor, the stdio objects are
            created, which allocates Ruby objects, which fires the tracepoint.
            However, the tracepoint machinery tries to dereference the control frame
            (ec->cfp->pc), which isn't set up yet and so crashes with a null pointer
            dereference.

            Fix this by not firing GC tracepoints if cfp isn't yet set up.
            ---
             gc.c                         |  1 +
             test/objspace/test_ractor.rb | 17 +++++++++++++++++
             2 files changed, 18 insertions(+)
             create mode 100644 test/objspace/test_ractor.rb

commit 5c5a1135b2e688eca7dbc7ce085f37a4d9fa3fd1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-25 14:25:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-25 14:25:37 +0900

    merge revision(s) 790cf4b6d0475614afb127b416e87cfa39044d67: [Backport #19115]

            Fix autoload status of statically linked extensions

            Previously, for statically-linked extensions, we used
            `vm->loading_table` to delay calling the init function until the
            extensions are required. This caused the extensions to look like they
            are in the middle of being loaded even before they're required.
            (`rb_feature_p()` returned true with a loading path output.) Combined
            with autoload, queries like `defined?(CONST)` and `Module#autoload?`
            were confused by this and returned nil incorrectly. RubyGems uses
            `defined?` to detect if OpenSSL is available and failed when OpenSSL was
            available in builds using `--with-static-linked-ext`.

            Use a dedicated table for the init functions instead of adding them to
            the loading table. This lets us remove some logic from non-EXTSTATIC
            builds.

            [Bug #19115]
            ---
             load.c                     | 55 +++++++++++++++++++++++++++++++++++-----------
             test/ruby/test_autoload.rb | 18 +++++++++++++++
             vm.c                       |  3 +++
             vm_core.h                  |  9 ++++++++
             4 files changed, 72 insertions(+), 13 deletions(-)

commit a308900b74ff897de50dc9c212c03daaf642f003
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-25 11:30:36 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-25 11:30:36 +0900

    fixup for 823835499539aa53128a025ab72eb00c288dfb09.

commit 823835499539aa53128a025ab72eb00c288dfb09
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-25 11:07:09 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-25 11:07:09 +0900

    merge revision(s) d6ce4180a5b4dacbac895c9911031a6df6c61136: [Backport #19243]

            Windows: Fix encoding of Dir.home

            Dir.home returns an UTF-8 string since ruby-3.0, but the actual
            encoding of the bytes was CP_ACP or CP_OEMCP.
            That led to invalid bytes when calling Dir.home with an unicode
            username.
            ---
             spec/ruby/core/dir/home_spec.rb | 11 +++++++++++
             win32/file.c                    |  3 ++-
             2 files changed, 13 insertions(+), 1 deletion(-)

commit 810ae06c06312908fc1a7284773d8a9101ee145b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-25 11:04:33 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-25 11:04:33 +0900

    merge revision(s) 2e7e153a2af1456515d43b6381e38534b069b1c2: [Backport #19242]

            [Bug #19242] Prohibit circular causes to be loaded

            ---
             error.c                     |  4 ++++
             eval.c                      |  4 ++++
             eval_error.c                | 11 +++++++++++
             test/ruby/test_exception.rb | 12 ++++++++++++
             4 files changed, 31 insertions(+)

commit 8c99882dad0b6fedbd656889829a3780366bd8b6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-25 10:33:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-25 10:33:20 +0900

    merge revision(s) cd5cafa4a380e2459862b6e99ff0c381362ef1be: [Backport #18827]

            Respect the encoding of the source [Bug #18827]

            Do not override the input string encoding at the time of preparation,
            the source encoding is not determined from the input yet.
            ---
             parse.y                  | 26 ++++++++++++++++----------
             test/ruby/test_ast.rb    | 13 +++++++++++++
             test/ruby/test_syntax.rb |  9 +++++++++
             3 files changed, 38 insertions(+), 10 deletions(-)

commit 477ab3f6c7f14c79e13f694463aa06a59206dda1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-25 10:31:31 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-25 10:31:31 +0900

    merge revision(s) c5475f42694eff35465c3332e0182c0611ca5918: [Backport #18748]

            Fix Range#cover? returning true for beginless ranges of different
             types

            Previously `(2..).cover?("2"..)` was false, but
            `(..2).cover?(.."2")` was true.  This changes it so both are false,
            treating beginless ranges the same as endless ranges in regards to
            type checks.

            This also adds documentation to #cover? to describe behavior with
            beginless and endless ranges, testing each documentation example,
            which is how this bug was found.

            Fixes [Bug #18155]
            ---
             range.c                 | 54 ++++++++++++++++++++++++++++++++++++++++++++++++-
             test/ruby/test_range.rb | 29 ++++++++++++++++++++++++++
             2 files changed, 82 insertions(+), 1 deletion(-)

commit 02bee9d4d404b5134d19b16bc489c20459cce4ac
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-25 10:12:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-25 10:12:02 +0900

    merge revision(s) f229b36087f1b387d77af8f3fa50f9bffd2fd44e: [Backport #18989]

            Fix test fail with assert_ractor outside of ruby/ruby repo

              Revert 806583c093ecc2d67830f0a8f0d94decf0ed71e5
            ---
             tool/lib/core_assertions.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 6ee749a52817fc463bbc2e93e5c3874a8c9aacf9
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-25 09:50:40 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-25 09:50:40 +0900

    Revert "Skip the test for [Bug #19316] for a while."

    This reverts commit 82d763c94ad693a2af8086df8e0455b7de2d2ce3,
    and add exit: :any to assert_compile.

    Co-authored-by: Alan Wu <alansi.xingwu@shopify.com>

commit bc04b38f72ba1f261fbb3e881e6ae65c4bc77797
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-21 16:08:47 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-21 16:25:25 +0900

    merge revision(s) 96d1acfdf6c6b42f2029f44d5b5920961d6efa92: [Backport #19161]

            [Bug #19161] Check for TLS usability

            On all platforms using GCC, even other than darwin.
            ---
             configure.ac | 13 +++++++------
             1 file changed, 7 insertions(+), 6 deletions(-)

commit 5428bdc1daed12d1e142a854fc037a1a4eb647c9
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-21 15:34:59 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-21 15:34:59 +0900

    merge revision(s) dd28c55a7cd6780dad637b4d6a20507fbfc6af4a: [Backport #19445]

            [Bug#19445] Fix keyword splat in enumerator

            Extracted arguments do not have keyword hash to splat.
            ---
             numeric.c                 | 2 +-
             test/ruby/test_numeric.rb | 3 +++
             2 files changed, 4 insertions(+), 1 deletion(-)

commit caedcf3ee8e445f90df88ccf2f745c9d9f7ccc35
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-21 15:33:33 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-21 15:33:33 +0900

    merge revision(s) 86de48e9f69b665ba9ffb5bdc5a181a3adb1a7b8: [Backport #19419]

            Remove ibf_dumper's WB_PROTECTED status

            It doesn't have the right write barriers in place. For example, there is

                rb_mark_set(dump->global_buffer.obj_table);

            in the mark function, but there is no corresponding write barrier when
            adding to the table in the
            `ibf_dump_object() -> ibf_table_find_or_insert() -> st_insert()` code path.

            To insert write barrier correctly, we need to store the T_STRUCT VALUE
            inside `struct ibf_dump`. Instead of doing that, let's just demote it
            to WB unproected for correctness. These dumper object are ephemeral so
            there is not a huge benefit for having them WB protected.

            Users of the bootsnap gem ran into crashes due to this issue:
            https://github.com/Shopify/bootsnap/issues/436

            Fixes [Bug #19419]
            ---
             compile.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 26b3f0b6a9489860e1d312369d784495b080daa3
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-21 15:32:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-21 15:32:44 +0900

    merge revision(s) 8ce2fb9bbbaea14737c84385b1573f743a30f773,3a0f6ce1d31eefd8af01b50f3632a64d64e8f8c1: [Backport #19415]

            Only emit circular dependency warning for owned thread shields [Bug
             #19415]

            If multiple threads attemps to load the same file concurrently
            it's not a circular dependency issue.

            So we check that the existing ThreadShield is owner by the current
            fiber before warning about circular dependencies.
            ---
             internal/thread.h                                     |  1 +
             load.c                                                |  3 ++-
             spec/ruby/core/kernel/shared/require.rb               | 11 +++++++++++
             spec/ruby/fixtures/code/concurrent_require_fixture.rb |  4 ++++
             test/ruby/test_require.rb                             |  3 ---
             thread.c                                              | 11 +++++++++++
             6 files changed, 29 insertions(+), 4 deletions(-)
             create mode 100644 spec/ruby/fixtures/code/concurrent_require_fixture.rb

            Use Thread.pass until thread.stop? to wait for thread to block

            [Bug #19415]

            It should be more reliable
            ---
             spec/ruby/fixtures/code/concurrent_require_fixture.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 485e0e46a58ff1a28eecd63b804b3dbea4b95b98
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-21 15:25:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-21 15:25:32 +0900

    merge revision(s) 3a7367ccc319499127ead147e5a08f769e44208e: [Backport #19403]

            mkconfig: Map `includedir` only for system ruby

            Only when installing to the system path on macOS, prepend '$(SDKROOT)'
            and remap `includedir`.
            Fix https://github.com/rbenv/ruby-build/discussions/2123
            ---
             test/mkmf/test_config.rb | 4 ++--
             test/test_rbconfig.rb    | 9 ---------
             tool/mkconfig.rb         | 4 +++-
             3 files changed, 5 insertions(+), 12 deletions(-)

commit 0d00732d39de1e5ecce738260a1e49d8af52e12a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-21 15:22:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-21 15:22:57 +0900

    merge revision(s) c6f84e918943a0bf8db6fee556fc53180d257510: [Backport #19398]

            [Bug #19398] Memory leak in WeakMap

            There's a memory leak in ObjectSpace::WeakMap due to not freeing
            the `struct weakmap`. It can be seen in the following script:

            ```
            100.times do
              10000.times do
                ObjectSpace::WeakMap.new
              end

              # Output the Resident Set Size (memory usage, in KB) of the current Ruby process
              puts `ps -o rss= -p #{$$}`
            end
            ```
            ---
             gc.c                      | 1 +
             test/ruby/test_weakmap.rb | 9 +++++++++
             2 files changed, 10 insertions(+)

commit 82d763c94ad693a2af8086df8e0455b7de2d2ce3
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-21 14:16:28 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-21 14:16:28 +0900

    Skip the test for [Bug #19316] for a while.

commit d28464c4ae968a180e80e3f9261bcfec08ae7702
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-21 13:59:41 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-21 13:59:41 +0900

    merge revision(s) 0bb07e5ba40cdc45d55743dd1ebaadd7e7363e7f: [Backport #19284]

            Fix test when Ruby is verbose

            The test added in 90a80eb0 fails if Ruby is verbose, it outputs the
            following line to stderr:

                RUBY_GC_HEAP_INIT_SLOTS=100 (default value: 10000)
            ---
             test/ruby/test_gc.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 1d24a931c458c93463da1d5885f33edef3677cc2
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-21 13:56:55 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-21 13:56:55 +0900

    merge revision(s) 21dced8b01823a991829b66ffdc8ffc635965c76: [Backport #19389]

            [ruby/stringio] [Bug #19389] Fix chomping with longer separator

            https://github.com/ruby/stringio/commit/eb322a9716
            ---
             ext/stringio/stringio.c        | 5 +++--
             test/stringio/test_stringio.rb | 2 ++
             2 files changed, 5 insertions(+), 2 deletions(-)

commit 8322413e58bdce11136c33aec3e0611b2b135cd8
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-21 12:25:31 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-21 12:25:31 +0900

    merge revision(s) 72eb33066fa9e7dacb7470cd140b219abe37667e: [Backport #19320]

            Fix off-by-one error in rb_vm_each_stack_value

            Applying the following patch to test/erb/test_erb.rb and running that
            file will cause Ruby to crash on my machine (macOS 13.1 on M1 Pro):

            ```
            --- a/test/erb/test_erb.rb
            +++ b/test/erb/test_erb.rb
            @@ -7,6 +7,12 @@
             class TestERB < Test::Unit::TestCase
               class MyError < RuntimeError ; end

            +  def setup
            +    GC.auto_compact = true
            +    GC.stress = true
            +    GC.verify_compaction_references(expand_heap: true, toward: :empty)
            +  end
            +
            ```

            It crashes with the following log:

            ```
            /Users/peter/src/ruby/lib/erb/compiler.rb:276: [BUG] Segmentation fault at 0x00000001083a8690
            ...
            -- C level backtrace information -------------------------------------------
            ...
            /Users/peter/src/ruby/build/ruby(rb_vm_each_stack_value+0xa8) [0x104cc3a44] ../vm.c:2737
            /Users/peter/src/ruby/build/ruby(rb_vm_each_stack_value+0xa8) [0x104cc3a44] ../vm.c:2737
            /Users/peter/src/ruby/build/ruby(check_stack_for_moved+0x2c) [0x104b272a4] ../gc.c:5512
            /Users/peter/src/ruby/build/ruby(gc_compact_finish) ../gc.c:5534
            /Users/peter/src/ruby/build/ruby(gc_sweep_compact) ../gc.c:8653
            /Users/peter/src/ruby/build/ruby(gc_sweep) ../gc.c:6196
            /Users/peter/src/ruby/build/ruby(has_sweeping_pages+0x0) [0x104b19c54] ../gc.c:9568
            /Users/peter/src/ruby/build/ruby(gc_rest) ../gc.c:9570
            ```

            This crash happens because it's reading the VALUE at sp. But since
            sp points to the top of the stack, it's reading the VALUE above the
            top of the stack, which is causing this segfault.

            Fixes [Bug #19320]
            ---
             vm.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 782a9c2ddfcc84c3bd3a1fa153f7ac1f3e92a2e1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-21 12:23:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-21 12:23:37 +0900

    merge revision(s) 90a80eb076429978e720e11fb17a3cbb96de3454: [Backport #19284]

            Fix integer underflow when using HEAP_INIT_SLOTS

            There is an integer underflow when the environment variable
            RUBY_GC_HEAP_INIT_SLOTS is less than the number of slots currently
            in the Ruby heap.

            [Bug #19284]
            ---
             gc.c                 | 25 +++++++++++++------------
             test/ruby/test_gc.rb |  5 +++++
             2 files changed, 18 insertions(+), 12 deletions(-)

commit c660aaf439dcd609e4e23253372c8ec6d567ce10
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-21 12:10:35 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-21 12:10:35 +0900

    merge revision(s) aeddc19340c7116d48fac3080553fbb823857d16: [Backport #19316]

            YJIT: Save PC and SP before calling leaf builtins (#7090)

            Previously, we did not update `cfp->sp` before calling the C function of
            ISEQs marked with `Primitive.attr! "inline"` (leaf builtins). This
            caused the GC to miss temporary values on the stack in case the function
            allocates and triggers a GC run. Right now, there is only a few leaf
            builtins in numeric.rb on Integer methods such as `Integer#~`. Since
            these methods only allocate when operating on big numbers, we missed
            this issue.

            Fix by saving PC and SP before calling the functions -- our usual
            protocol for calling C functions that may allocate on the GC heap.

            [Bug #19316]
            ---
             test/ruby/test_yjit.rb | 16 ++++++++++++++++
             yjit/src/codegen.rs    |  4 ++++
             2 files changed, 20 insertions(+)

commit 159930b7857bd3fe603840f686edffb54693d2a7
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-21 12:02:04 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-21 12:02:04 +0900

    merge revision(s) d8ef0a98c670449b20436947f5ebbd327ed5ab0d: [Backport #19319]

            [Bug #19319] Fix crash in rb_str_casemap

            The following code crashes on my machine:

            ```
            GC.stress = true

            str = "testing testing testing"

            puts str.capitalize
            ```

            We need to ensure that the object `buffer_anchor` remains on the stack
            so it does not get GC'd.
            ---
             string.c | 2 ++
             1 file changed, 2 insertions(+)

commit eba3f787cbd38acf60fff6bdb450aacfc2e9c3a1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-21 12:00:17 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-21 12:00:17 +0900

    merge revision(s) 837ef8911c638c3e2bdb6af710de7c1fac7b5f90: [Backport #19305]

            Fix crash in TracePoint c_call for removed method

            trace_arg->id is the ID of the original method of an aliased method. If
            the original method is removed, then the lookup will fail. We should use
            trace_arg->called_id instead, which is the ID of the aliased method.

            Fixes [Bug #19305]
            ---
             test/ruby/test_settracefunc.rb | 23 +++++++++++++++++++++++
             vm_trace.c                     |  2 +-
             2 files changed, 24 insertions(+), 1 deletion(-)

commit 3efc43aace4e051f618b10e82bd82e93076dc757
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-03-21 11:54:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-03-21 11:54:37 +0900

    merge revision(s) 542e984d82fa25098eb15398d716d907acc52b93: [Backport #19292]

            [Bug #19292] Re-initialize tm when wday or yday is not set

            ---
             test/ruby/test_time.rb |  3 ++-
             time.c                 | 31 ++++++++++++++++++++++---------
             2 files changed, 24 insertions(+), 10 deletions(-)

commit 0602df301cd76a3f1b444c4742b288bc6aed80ac
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-02-23 15:14:27 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-02-23 15:14:27 +0900

    merge revision(s) 613fca01486e47dee9364a2fd86b5f5e77fe23c8: [Backport #19189]

            [Bug #19189] Fallback to the default "pkg-config"

            ---
             lib/mkmf.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 9f072e9ae1bae2d76334c9e97a47280779768859
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-02-23 15:10:50 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-02-23 15:10:50 +0900

    merge revision(s) 8038d5e40a079d60dfcf7cab1155528959760c28: [Backport #18765]

            Revert flawed doc for slice_after, slice_when, and chunk_while
             (#5952)

            Restores doc for the methods that were cited in https://bugs.ruby-lang.org/issues/18765.
            ---
             enum.c | 162 +++++++++++++++++++++++++++++++++++++++++++----------------------
             1 file changed, 107 insertions(+), 55 deletions(-)

commit 536f5ba0d48c033e63398d1751aebd0a11bcc6ff
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-02-23 14:36:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-02-23 14:36:37 +0900

    merge revision(s) 3ddf6ad4d2f6dae4caa00b8c407768c7062099a0: [Backport #18629]

            Private local variables should shadow outer variables [Bug #18629]

            ---
             parse.y                 | 3 ++-
             test/ruby/test_parse.rb | 4 ++++
             2 files changed, 6 insertions(+), 1 deletion(-)

commit d485a5dc783e23de28fb9eab7fc6c12ae5c35a23
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-02-23 12:46:42 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-02-23 12:46:42 +0900

    bump patchlevel

commit 76c61c9993e59af0b4c400b44f169f4af99c3efa
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-02-16 17:54:09 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-02-23 12:45:16 +0900

    Backport https://github.com/ruby/ruby/pull/7321

commit 4141989b2aef2993bb19140a4be355d1c68b8be1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-02-23 12:41:50 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-02-23 12:41:50 +0900

    merge revision(s) 656f25987cf2885104d5b13c8d3f5b7d32f1b333,98074a57ca9f3169fe9da9af6c49b636d37db16f,745dcf5326ea2c8e2047a3bddeb0fbb7e7d07649,b335d899fff3cc22b022c9ee2ceb636d714bf1a7: [Backport #19153]

            [ruby/cgi] Fix test_cgi_cookie_new_with_domain to pass on older
             rubies

            https://github.com/ruby/cgi/commit/05f0c58048
            ---
             test/cgi/test_cgi_cookie.rb | 8 ++++----
             1 file changed, 4 insertions(+), 4 deletions(-)

            [ruby/cgi] Prepare to release 0.3.6

            https://github.com/ruby/cgi/commit/710a647855
            ---
             lib/cgi.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            [ruby/cgi] Loosen the domain regex to accept '.'
             (https://github.com/ruby/cgi/pull/29)

            * Loosen the domain regex to accept '.'

            Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>

            https://github.com/ruby/cgi/commit/5e09d632f3
            Co-authored-by: Hiroshi SHIBATA <hsbt@ruby-lang.org>
            ---
             lib/cgi/cookie.rb           | 2 +-
             test/cgi/test_cgi_cookie.rb | 3 +++
             2 files changed, 4 insertions(+), 1 deletion(-)

            [ruby/cgi] Bump up 0.3.6

            https://github.com/ruby/cgi/commit/827b7d43cc
            ---
             lib/cgi.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit a4ab9921a15fccca606e5f1ec741f802d39392b1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-12-17 14:25:12 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-12-17 14:25:12 +0900

    common.mk: test-bundled-gems-prepare: pin-down hoe version.

    hoe-4.0.0 causes test failure in minitest.
    https://github.com/ruby/actions/actions/runs/3715629538

commit a1124dc162810f86cb0bff58cde24064cfc561bc
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-12-09 21:11:47 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-12-09 21:11:47 +0900

    merge revision(s) 58cc3c9f387dcf8f820b43e043b540fa06248da3: [Backport #19187]

            [Bug #19187] Fix for tzdata-2022g

            ---
             test/ruby/test_time_tz.rb | 21 +++++++++++++++------
             1 file changed, 15 insertions(+), 6 deletions(-)

commit 6dfa45c47bf58e5382c3e556b220c2cc8fd506e6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-11-24 22:52:45 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-11-24 22:52:45 +0900

    bump teeny version to 3.1.4.

commit 9ca4b96f9e2a1ef0f6000f0a994bc76f7f03a86a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-11-23 13:32:27 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-11-23 13:32:27 +0900

    disable remote tests in debug.gem on macOS.

commit 16ea2213295137bb25f10225408c54de452a507b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-11-22 13:50:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-11-22 23:04:45 +0900

    Merge CGI-0.3.5

commit 14704023ec57546b1bed85d54f4f425986385ab4
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-11-22 20:32:19 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-11-22 21:50:22 +0900

    Merge RubyGems-3.3.26 and Bundler-2.3.26

commit b102175b4dcfebe7455e3b27653fab0288f68326
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-11-22 20:31:54 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-11-22 21:50:22 +0900

    Merge RubyGems-3.3.25 and Bundler-2.3.25

commit 6f59f0bebc5fe1ae84028832cc777160d853e302
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-11-22 20:31:40 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-11-22 21:50:22 +0900

    Merge RubyGems-3.3.24 and Bundler-2.3.24

commit 8f2586f1985041b8be33358052fa647d02bf2aea
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-11-22 20:55:17 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-11-22 20:55:17 +0900

    merge revision(s) 36f297e62108072b9377d927321928b994f66a93:

            Use valid tokens as cookie names

            ---
             spec/ruby/library/cgi/cookie/name_spec.rb  | 12 ++++++------
             spec/ruby/library/cgi/cookie/parse_spec.rb | 10 +++++-----
             2 files changed, 11 insertions(+), 11 deletions(-)

commit 012015d762d000966a33fcea5f3069decd9d4007
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-11-13 17:07:58 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-11-13 17:07:58 +0900

    merge revision(s) b8f0dc59d52266d9fbfc039e2f4b0f727c62baa0: [Backport #18599]

            rb_provide_feature: Prevent $LOADED_FEATURES from being copied

            [Bug #18599]

            `vm->loaded_features` and `vm->loaded_features_snapshot` both share the
            same root. When a feature is pushed into `loaded_features`, the sharing
            is broken and `loaded_features` is copied.

            So an application requiring 1000 files, will allocate 1000 arrays of
            increasing size, which is very wasteful.

            To avoid this, we first clear the snapshot, so that `loaded_features`
            can directly be pushed into.

            Co-Authored-By: Peter Zhu <peter.zhu@shopify.com>
            ---
             load.c | 4 ++++
             1 file changed, 4 insertions(+)

commit f8044a770009b78d46b583600c9bd6660328303f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-11-13 11:22:53 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-11-13 11:22:53 +0900

    merge revision(s) 131c31a9209c61f84d318aa18b61f468f48b8219: [Backport #19081]

            [Bug #19081] Show the caller location in warning for Ractor

            The internal location in ractor.rb is not usefull at all.
            ```
            $ ruby -e 'Ractor.new {}'
            <internal:ractor>:267: warning: Ractor is experimental, ...
            ```
            ---
             bootstraptest/test_ractor.rb | 6 ++++++
             ractor.c                     | 6 ------
             ractor.rb                    | 4 ++++
             3 files changed, 10 insertions(+), 6 deletions(-)

commit 728d9f18348bcffedb0880c67015f08a7c19665f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-11-13 11:20:01 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-11-13 11:20:01 +0900

    merge revision(s) 011d4c57d21220249600dfb76db84840550da019: [Backport #19106]

            [Bug #19106] Normalize time at 24:00:00 with a timezone object

            ---
             test/ruby/test_time_tz.rb |  5 +++++
             time.c                    | 24 ++++++++++++++++--------
             2 files changed, 21 insertions(+), 8 deletions(-)

commit 61818395312c6e765dc8e7be8bf32cd2c82fec39
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-11-13 11:18:27 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-11-13 11:18:27 +0900

    merge revision(s) eacedcfe44a0ae22bf54ddb7df193c48d4c857c6: [Backport #19105]

            mutex: Raise a ThreadError when detecting a fiber deadlock (#6680)

            [Bug #19105]

            If no fiber scheduler is registered and the fiber that
            owns the lock and the one that try to acquire it
            both belong to the same thread, we're in a deadlock case.

            Co-authored-by: Jean Boussier <byroot@ruby-lang.org>
            ---
             test/fiber/test_mutex.rb | 22 +++++++++++++++++++++-
             thread_sync.c            |  4 ++++
             2 files changed, 25 insertions(+), 1 deletion(-)

commit db1aa39ffcaa5b9f062639eb30c76959f4607a8e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-11-13 11:13:53 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-11-13 11:13:53 +0900

    merge revision(s) 199b59f065ce6f1c13b8424f35a70c513523211b: [Backport #19116]

            Fix bug in array pack with shared strings

            If string literals are long and they become shared, we need to make them
            independent before we can write to them. [Bug #19116]
            ---
             pack.c                  | 1 +
             test/ruby/test_array.rb | 6 ++++++
             2 files changed, 7 insertions(+)

commit 0f334f90d00821d32be0ba1835baa9efc61b782b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-11-05 14:37:11 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-11-05 14:37:11 +0900

    bump patchlevel

commit 4d1faefa10518ada452d5a85f4e43a8bfda847cc
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-10-31 11:25:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-11-05 14:35:57 +0900

    Merge reline-0.3.1

commit ad92236d245b791d14fd78bcb5a0a0789aa169c0
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-11-05 14:22:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-11-05 14:24:03 +0900

    merge revision(s) 2bb89b7f114e4beb3012f63e12e726ae23005e6f: [Backport #19101]

            Lower priority of `POSIX_MADV_DONTNEED`. (#6671)

            ---
             cont.c | 21 ++++++++++++++++++---
             1 file changed, 18 insertions(+), 3 deletions(-)

commit 01eab9a5d1886412869f85d4b87779f22d548867
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-11-05 14:20:23 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-11-05 14:24:03 +0900

    merge revision(s) 16953867ed8fc951364f05fdf0c9267799e3087a: [Backport #18380]

            We don't care about actual hostname resolution. (#6652)

            https://bugs.ruby-lang.org/issues/18380
            ---
             test/fiber/test_address_resolve.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 8572f02d63de2b99389df0791d6eacb77482afef
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-11-05 13:56:58 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-11-05 14:24:03 +0900

    merge revision(s) 35c794b26d406c39f90e188e3884003fe6aca532,725626d8905fe1ac4a2cf1c3e2db6412bf8f381f,b32a3f1275a8c7748f2134492ce3c532f277d261: [Backport #18964]

            Fixed by [Bug #18964]

            ---
             file.c | 3 ---
             1 file changed, 3 deletions(-)

            [Bug #18964] Update the code range of appended portion

            ---
             ext/-test-/econv/append.c   | 15 +++++++++++++++
             ext/-test-/econv/extconf.rb |  3 +++
             ext/-test-/econv/init.c     | 11 +++++++++++
             transcode.c                 | 34 ++++++++++++++++++++++++++++++----
             4 files changed, 59 insertions(+), 4 deletions(-)
             create mode 100644 ext/-test-/econv/append.c
             create mode 100644 ext/-test-/econv/extconf.rb
             create mode 100644 ext/-test-/econv/init.c

            [Bug #18964] Add test for `rb_econv_append`

            ---
             test/-ext-/econv/test_append.rb | 23 +++++++++++++++++++++++
             1 file changed, 23 insertions(+)
             create mode 100644 test/-ext-/econv/test_append.rb

commit 597ce7966c38e4f7fc7368a860ac2d056de794ba
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-11-05 13:52:01 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-11-05 14:24:03 +0900

    merge revision(s) 54cad3123a07583c90e85bcfc55ebd87124c1250: [Backport #19004]

            [Bug #19004] `Complex.polar` handles complex singular `abs` argument

            `Complex.polar` accepts Complex values as arguments for the polar form as long
            as the value of the complex has no imaginary part (ie it is 'real'). In
            `f_complex_polar` this is handled by extracting the real part of the arguments.
            However in the case `polar` is called with only a single argument, the absolute
            value (abs), then the Complex is created without applying a check on the type
            of abs, meaning it is possible to create a Complex where the real part is itself
            an instance of a Complex. This change removes the short circuit for the single
            argument case meaning the real part extraction is performed correctly
            (by f_complex_polar).

            Also adds an example to `spec/ruby/core/complex/polar_spec.rb` to check that
            the real part of a complex argument is correctly extracted and used in the
            resulting Complex real and imaginary parts.
            ---
             complex.c                            | 13 ++++++-------
             spec/ruby/core/complex/polar_spec.rb | 16 ++++++++++++++++
             2 files changed, 22 insertions(+), 7 deletions(-)

commit f08dee67dc41d961f9032ba18dc597ea072672fb
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-10-24 18:24:24 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-24 23:07:33 +0900

    Bump up net-http 0.3.0

commit 8bce7c1a725073b88cf96c3af6f37405b66d7db9
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-24 21:03:31 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-24 21:03:31 +0900

    merge revision(s) 399747926c323aca4f477ac3f8870b19229f4212:

            Update bundled gems list at 2022-10-24

            ---
             NEWS.md           | 2 +-
             gems/bundled_gems | 2 +-
             2 files changed, 2 insertions(+), 2 deletions(-)

commit 7c2b7229b953dbf5cd7f1229576226b6384c0e97
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-24 20:59:05 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-24 20:59:05 +0900

    merge revision(s) c506ddac6c88b14daf4a18bddf1c1e57be8d2225:

            Added assert_true and assert_false same as test-unit gem

            ---
             tool/lib/test/unit/assertions.rb | 16 ++++++++++++++++
             1 file changed, 16 insertions(+)

commit ffa439fd29141626878f4c4b56e86b2fee17294e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-23 19:14:08 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-23 19:14:08 +0900

    merge revision(s) 329d5424a479bb08e75bd750c51a5382e382731c: [Backport #19042]

            [Bug #19042] Fix Dir.glob brace with '/'

            Dir.glob brace pattern with '/' after '**' does not match
            paths in recursive expansion process.
            We expand braces with '/' before expanding a recursive.

            Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>
            ---
             dir.c                 |  2 +-
             test/ruby/test_dir.rb | 14 ++++++++++++++
             2 files changed, 15 insertions(+), 1 deletion(-)

commit 941c888b041decb45034572d766120f9be34986e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-23 19:11:45 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-23 19:11:45 +0900

    merge revision(s) bbe5ec78463f8d6ef2e1a3571f17357a3d9ec8e4: [Backport #18994]

            rb_int_range_last: properly handle non-exclusive range

            [Bug #18994]
            ---
             range.c                           | 8 ++++----
             spec/ruby/core/range/last_spec.rb | 6 ++++++
             2 files changed, 10 insertions(+), 4 deletions(-)

commit 5e25ba5d07d42f02485235e3962a4a28373c50e1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-23 19:09:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-23 19:09:57 +0900

    merge revision(s) 280b805d040fa537d5a459b40d4bfa6d49700905: [Backport #18909]

            [DOC] Fix documentation for ARGF#readlines

            [Bug #18909]
            ---
             io.c | 8 ++++----
             1 file changed, 4 insertions(+), 4 deletions(-)

commit 2c1b1eae7c984c9ff4788d382bc2edcd4ed91ef5
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-22 17:08:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-22 17:08:57 +0900

    merge revision(s) f88bff770578583a708093f4a0d8b1483a1d2039:

            [ruby/net-http] Revert "Replace Timeout.timeout in Net:HTTP#connect"

            This reverts commit https://github.com/ruby/net-http/commit/753cae3bbccc.

            https://github.com/ruby/net-http/commit/98caa38204
            ---
             lib/net/http.rb | 15 ++++++++-------
             1 file changed, 8 insertions(+), 7 deletions(-)

commit 3f3aebc23729f53c8c3564a33e7b83fc02072449
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-22 17:08:38 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-22 17:08:38 +0900

    merge revision(s) ac1bb6b51032ad8d34a1060f5f6b5b10b60dc183:

            [ruby/net-http] Rename `D` to `debug` in `Net::HTTP`

            Renames `D` to `debug` in `Net::HTTP` and introduces an alias for
            backwards compatibility. This was done for readability reasons, in that
            `D` did not clearly reflect what the method was doing and can cause some
            confusion.

            https://github.com/ruby/net-http/commit/582d6e87d6
            ---
             lib/net/http.rb | 33 ++++++++++++++++++---------------
             1 file changed, 18 insertions(+), 15 deletions(-)

commit 45d92966becb5332f3ccd001842688b62ab5a441
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 23:25:42 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 23:25:42 +0900

    Revert "merge revision(s) b9083c206aa02a824970e809d66607dd2c1a90f1:"

    This reverts commit 97e50a056e795f6551cae2f07a9996f4adf73a1f.

commit 0cbfccd6307e4306da7216d955cb5a78fc6062f9
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 22:52:05 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 22:52:05 +0900

    merge revision(s) 7e24ebc649b9b12e5fc704d7fc7563aeaf589e03:

            Disable msystem: MINGW64 job on GitHub Actions (#6545)

            ---
             .github/workflows/mingw.yml | 5 +----
             1 file changed, 1 insertion(+), 4 deletions(-)

commit 74d7093283b729557232b6dc30b848b1ae958ba5
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 22:48:29 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 22:48:29 +0900

    merge revision(s) 881bc2a1765e7c19ab389c53841adc5ac329f1aa:

            Skip running a DRb test on MinGW

            It hangs even after a retry
            https://github.com/ruby/ruby/runs/7966439530?check_suite_focus=true

            We contacted GitHub Suppport about this before, and we concluded that
            the problem is on our end. Unfortunately we don't have a bandwidth to
            fix this MinGW problem, so until we get to work on it, this should be
            just skipped to avoid a sporadic CI timeout.
            ---
             test/drb/drbtest.rb      | 1 +
             test/drb/test_drbssl.rb  | 4 ++++
             test/rinda/test_rinda.rb | 2 +-
             3 files changed, 6 insertions(+), 1 deletion(-)

commit 29414e004f6d84f35f2619bc05a2619ecb093908
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 22:47:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 22:47:30 +0900

    merge revision(s) 232e2f598103c8eda37d08913665b72b6f787e3f:

            Skip TupleSpaceProxyTest on MINGW64 too

            It wasn't specific to UCRT64

            https://github.com/ruby/ruby/runs/7062992464
            ---
             test/rinda/test_rinda.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 192aed9fa22c3043caedec6d0a12dce0371ddfd8
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 22:47:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 22:47:16 +0900

    merge revision(s) 49d59215506a30c8a11766627f7af0cdfe0de9d4:

            Fix Rinda test teardown for omitted tests

            New test failures on MINGW appeared after
            c2e37c8ff7da395f33fae546d9ae9e2408fc9236.

                  1) Error:
                Rinda::TupleSpaceProxyTest#test_00_template:
                NoMethodError: undefined method `stop_service' for nil:NilClass
                    D:/a/ruby/ruby/src/test/rinda/test_rinda.rb:516:in `teardown'

                  2) Error:
                Rinda::TupleSpaceProxyTest#test_ruby_talk_264062:
                NoMethodError: undefined method `stop_service' for nil:NilClass
                    D:/a/ruby/ruby/src/test/rinda/test_rinda.rb:516:in `teardown'

            Teardown happens even when the test is omitted.

            See: https://github.com/ruby/ruby/runs/7058984522
            ---
             test/rinda/test_rinda.rb | 4 ++++
             1 file changed, 4 insertions(+)

commit ad126996f34f19b3fc78371582dccabd28a6c0d3
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 22:46:59 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 22:46:59 +0900

    merge revision(s) c2e37c8ff7da395f33fae546d9ae9e2408fc9236:

            Try skipping TupleSpaceProxyTest on MinGW UCRT64

            As you all know, MinGW UCRT64 CI has randomly got stuck despite its
            "Finished tests" output.

            Looking at the logs closely, it seems like all of the recent such
            reproductions end with the following output:

            ```
              Retrying hung up testcases...
              [ 1/14] Rinda::TupleSpaceProxyTest#test_ruby_talk_264062 = 0.21 s
              [ 2/14] Rinda::TupleSpaceProxyTest#test_00_template = 0.01 s
              [ 3/14] Rinda::TupleSpaceProxyTest#test_inp_rdp = 0.00 s
              [ 4/14] Rinda::TupleSpaceProxyTest#test_core_03_notify = 0.01 s
              [ 5/14] Rinda::TupleSpaceProxyTest#test_00_renewer = 0.01 s
              [ 6/14] Rinda::TupleSpaceProxyTest#test_cancel_02 = 0.11 s
              [ 7/14] Rinda::TupleSpaceProxyTest#test_00_DRbObject = 0.00 s
              [ 8/14] Rinda::TupleSpaceProxyTest#test_core_02 = 0.11 s
              [ 9/14] Rinda::TupleSpaceProxyTest#test_core_01 = 0.11 s
              [10/14] Rinda::TupleSpaceProxyTest#test_remote_array_and_hash = 0.01 s
              [11/14] Rinda::TupleSpaceProxyTest#test_00_tuple = 0.00 s
              [12/14] Rinda::TupleSpaceProxyTest#test_take_bug_8215 = 0.41 s
              [13/14] Rinda::TupleSpaceProxyTest#test_cancel_01 = 0.11 s
              [14/14] Rinda::TupleSpaceProxyTest#test_symbol_tuple = 0.01 s
              Finished tests in 719.252845s, 29.4292 tests/s, 3838.7154 assertions/s.
              21167 tests, 2761007 assertions, 0 failures, 0 errors, 708 skips
            ```

            https://github.com/ruby/ruby/runs/7057789554

            While it seems to be retried successfully, given that it hungs up once
            and this appears all the time, this test class seems a bit suspicious.
            To check if it's related, let me try disabling this for now.
            ---
             test/rinda/test_rinda.rb | 3 +++
             1 file changed, 3 insertions(+)

commit 959a9fc4edfd0184a5c9a78ab7bc0bdbd3f6c2b2
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 22:42:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 22:42:44 +0900

    merge revision(s) 137e69b48153dfd47851a1548eeefc6c7c843e92:

            Bump actions/checkout from 2 to 3

            Bumps [actions/checkout](https://github.com/actions/checkout) from 2 to 3.
            - [Release notes](https://github.com/actions/checkout/releases)
            - [Changelog](https://github.com/actions/checkout/blob/main/CHANGELOG.md)
            - [Commits](https://github.com/actions/checkout/compare/v2...v3)

            ---
            updated-dependencies:
            - dependency-name: actions/checkout
              dependency-type: direct:production
              update-type: version-update:semver-major
            ...

            Signed-off-by: dependabot[bot] <support@github.com>
            ---
             .github/workflows/baseruby.yml           | 2 +-
             .github/workflows/bundled_gems.yml       | 2 +-
             .github/workflows/check_dependencies.yml | 2 +-
             .github/workflows/check_misc.yml         | 2 +-
             .github/workflows/codeql-analysis.yml    | 2 +-
             .github/workflows/compilers.yml          | 2 +-
             .github/workflows/mingw.yml              | 2 +-
             .github/workflows/mjit.yml               | 2 +-
             .github/workflows/spec_guards.yml        | 2 +-
             .github/workflows/ubuntu.yml             | 2 +-
             .github/workflows/wasm.yml               | 2 +-
             .github/workflows/windows.yml            | 2 +-
             .github/workflows/yjit-ubuntu.yml        | 2 +-
             .github/workflows/yjit_asm_tests.yml     | 2 +-
             14 files changed, 14 insertions(+), 14 deletions(-)

commit d819d15db32f6021883448ca7799b602bc0d320d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 22:41:17 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 22:41:17 +0900

    merge revision(s) 9deacb31552e01f1688cc95774c8de735d711443:

            Bump actions/cache from 2 to 3

            Bumps [actions/cache](https://github.com/actions/cache) from 2 to 3.
            - [Release notes](https://github.com/actions/cache/releases)
            - [Commits](https://github.com/actions/cache/compare/v2...v3)

            ---
            updated-dependencies:
            - dependency-name: actions/cache
              dependency-type: direct:production
              update-type: version-update:semver-major
            ...

            Signed-off-by: dependabot[bot] <support@github.com>
            ---
             .github/workflows/baseruby.yml           | 2 +-
             .github/workflows/bundled_gems.yml       | 2 +-
             .github/workflows/check_dependencies.yml | 2 +-
             .github/workflows/check_misc.yml         | 2 +-
             .github/workflows/codeql-analysis.yml    | 2 +-
             .github/workflows/compilers.yml          | 2 +-
             .github/workflows/mingw.yml              | 2 +-
             .github/workflows/mjit.yml               | 2 +-
             .github/workflows/ubuntu.yml             | 2 +-
             .github/workflows/windows.yml            | 8 ++++----
             .github/workflows/yjit-ubuntu.yml        | 2 +-
             11 files changed, 14 insertions(+), 14 deletions(-)

commit 97e50a056e795f6551cae2f07a9996f4adf73a1f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 22:38:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 22:38:20 +0900

    merge revision(s) b9083c206aa02a824970e809d66607dd2c1a90f1:

            [MSWin] Cache installed vcpkg packages

            ---
             .github/workflows/windows.yml | 7 +++++++
             1 file changed, 7 insertions(+)

commit b31a707396718c344ca9b50e28edc08b2bae20d1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 22:38:01 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 22:38:01 +0900

    merge revision(s) 7ce3a100f2aef897ee1062dcda23b70cd5574866:

            Fold command line items

            ---
             .appveyor.yml                 | 28 +++++++++++++++++++++++++---
             .github/workflows/windows.yml |  7 +++++--
             2 files changed, 30 insertions(+), 5 deletions(-)

commit 5fe7a7ada09158c89e8d3d533c1d1664b4bb2c43
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 22:35:09 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 22:35:09 +0900

    merge revision(s) c54eac661350be3c5b991eff349080910966add3:

            Show tool versions

            ---
             .github/workflows/mingw.yml | 12 ++++++++++++
             1 file changed, 12 insertions(+)

commit 6ea0a23549a4820d0a961e1c6621cae88f81427c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 22:32:14 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 22:32:14 +0900

    bump patchlevel

commit ededdf7d72f0738184c1f60d59e85b9236832444
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-10-12 17:54:09 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 20:24:01 +0900

    Bump up rbs-2.7.0

commit 1931c78762bd436090a6f935ef1a7e573c29e9cf
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 18:54:54 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 18:54:54 +0900

    merge revision(s) 41516b35418d6108c75d9f2190a846ded6a47108:

            Extract bundled gems by BASERUBY

            ---
             common.mk | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

commit 782bb163b7f08adf9f744ecade758268726e8775
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 17:17:54 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 17:17:54 +0900

    merge revision(s) 91c05b34cd9ca9120c4a5e5e9fe772f2f0d1f6a3:

            Bundled gems test needs `prepare-gems`

            `prepare-gems` downloads and extracts the bundled gems, and these gems
            are built by `build-exts` now.
            ---
             .github/workflows/bundled_gems.yml | 5 +++++
             .github/workflows/compilers.yml    | 2 --
             .github/workflows/macos.yml        | 4 ++--
             .github/workflows/ubuntu.yml       | 4 ++--
             .github/workflows/yjit-ubuntu.yml  | 4 ++--
             5 files changed, 11 insertions(+), 8 deletions(-)

commit e9be76dc6937f15be8e6473cf726f395b749a7a7
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 16:23:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 16:23:21 +0900

    merge revision(s) 44a0a66559ee4a03a84c27feca05e9b1b0f59df8:

            Move to tool/lib/bundled_gem.rb

            ---
             common.mk               |  6 +++---
             defs/gmake.mk           |  4 ++--
             tool/gem-unpack.rb      | 53 -----------------------------------------------
             tool/lib/bundled_gem.rb | 55 +++++++++++++++++++++++++++++++++++++++++++++++++
             4 files changed, 60 insertions(+), 58 deletions(-)
             delete mode 100644 tool/gem-unpack.rb
             create mode 100644 tool/lib/bundled_gem.rb

commit 833076de9bceb34200d1bf21a9f75997fc387b67
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 16:13:01 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 16:17:48 +0900

    merge revision(s) abfd859b139545110e1fcdd8e99575d5e0bfb4e4:

            Remove github and git related files from extracted bundled gems

            ---
             common.mk     | 3 ++-
             defs/gmake.mk | 1 +
             2 files changed, 3 insertions(+), 1 deletion(-)

commit 939f8c0e665f49ce7b438b796a2e4b2785f290d8
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 15:35:24 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 15:35:24 +0900

    merge revision(s) de9c612d6342ae2ea5ae1e46b27abecf17c439b5:

            Also the tests should use the configured pkg-config

            ---
             test/mkmf/test_pkg_config.rb | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

commit e8cb6dae740d5c5613854f8b280a7b0cf5a0fa17
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 15:20:36 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 15:20:36 +0900

    merge revision(s) 518301883edee12218657c77ba977e2bde1b17d0:

            Fix parallel build on MINGW

            When the build is running with a base ruby then generating `x64-ucrt-ruby320.rc`
            could fail due to a missing dependency to `x64-mingw-ucrt-fake.rb`.
            This commit adds this dependency.

            A failing build looks like so:
            ```
            generating x64-mingw-ucrt-fake.rb
            generating x64-ucrt-ruby320.rc
            ../snapshot-master/win32/resource.rb:in `require': cannot load such file -- ./x64-mingw-ucrt-fake (LoadError)
            make: *** [GNUmakefile:57: x64-ucrt-ruby320.rc] Error 1
            make: *** Waiting for unfinished jobs....
            linking miniruby.exe
            x64-mingw-ucrt-fake.rb updated
            ```
            ---
             cygwin/GNUmakefile.in | 4 ++--
             template/Makefile.in  | 1 +
             2 files changed, 3 insertions(+), 2 deletions(-)

commit bef621fcabd50fe46e76ed9904eb5d1cf6654ec1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 15:19:05 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 15:19:05 +0900

    merge revision(s) 6f5305e0d2b4711b186ece8160716c7f9439ea8d:

            Exclude LIBPATHENV wrapper from PREP

            ---
             common.mk            | 4 ++--
             configure.ac         | 2 +-
             template/Makefile.in | 2 ++
             3 files changed, 5 insertions(+), 3 deletions(-)

commit 000cb2241425a6f073066bd6acc56190b361f9e8
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 15:18:26 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 15:18:26 +0900

    merge revision(s) bc5b9be1ee44817614bc8311e671fc79ca730625:

            Move duplicate dependencies

            ---
             common.mk            | 2 ++
             template/Makefile.in | 5 -----
             win32/Makefile.sub   | 2 --
             3 files changed, 2 insertions(+), 7 deletions(-)

commit c740605d425a472fb9d4451791bd75c327aa7aa5
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 15:12:41 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 15:12:41 +0900

    merge revision(s) 97ce030954dab3f219779e235bee53ba408fbaca:

            Load fake.rb at `BTESTRUBY`

            So that `mkmf` checks work from `make run`, and also remove
            duplicate `$(MINIRUBYOPT)` which is used in `$(MINIRUBY)`.
            ---
             common.mk            | 8 ++++----
             template/Makefile.in | 3 +--
             template/fake.rb.in  | 2 ++
             win32/Makefile.sub   | 2 +-
             4 files changed, 8 insertions(+), 7 deletions(-)

commit 57d14154a2e85bec2a5589810a4aa250b82ab864
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 15:01:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 15:01:57 +0900

    merge revision(s) 9de11fe796e8caca2d87650278028eb95c1e09a0:

            Quiet if the target is already linked the same source

            ---
             ext/extmk.rb  | 2 +-
             tool/ln_sr.rb | 6 ++++++
             2 files changed, 7 insertions(+), 1 deletion(-)

commit 022ab25878fe9e1edee757510e40ecaec9fb2b69
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 15:01:50 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 15:01:50 +0900

    merge revision(s) 59eadf3d25b0f53e7570f98f1801737af642f328:

            Ignore EACCES on Windows

            ---
             tool/ln_sr.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 4388849ad3076ab0fe3586445cc1175a0358aba4
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 15:01:10 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 15:01:10 +0900

    merge revision(s) e5e6b87e265b95620821f7abac56b5ab90d4c1fd:

            Create temporary file exclusively and clean

            ---
             ext/extmk.rb | 9 +++++++--
             1 file changed, 7 insertions(+), 2 deletions(-)

commit 0146681df8f064888038d51207cf520bdf74ac0d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 14:57:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 14:57:20 +0900

    merge revision(s) 6af7212004c0b98f09350b53a032f94f3a1e666c:

            Make extensions under `Gem.extension_api_version` directory

            ---
             ext/extmk.rb | 3 ++-
             1 file changed, 2 insertions(+), 1 deletion(-)

commit 3f3a5ec04222fd03945e3e6ef2e79ff7d07ce677
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 14:56:31 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 14:56:31 +0900

    merge revision(s) 6c1d7dab52b9bd26cbb624634b4acb86ba37aa7f:

            Fix conversion from absolute path to relative path

            ---
             tool/ln_sr.rb | 25 +++++++++++++++----------
             1 file changed, 15 insertions(+), 10 deletions(-)

commit 5822577a9b5e41b6c9187bce630b092d1cd591dc
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 14:55:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 14:55:30 +0900

    merge revision(s) c093e7d64545640c8f2e7bb3eb24e3f9e24fb1c5:

            Avoid to symlink under symlink

            ---
             ext/extmk.rb  |  2 +-
             tool/ln_sr.rb | 21 ++++++++++++++-------
             2 files changed, 15 insertions(+), 8 deletions(-)

commit d8c232935ea5920fd8d023db02b9443488da7252
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 14:54:55 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 14:54:55 +0900

    merge revision(s) 78d2be69b500e4552e0e75fdefd26606a0506009:

            Move copying/linking extra files to Makefile so removed by `clean`

            ---
             ext/extmk.rb  |  81 ++++++++++++++++++++++++-----------------
             tool/ln_sr.rb | 113 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
             2 files changed, 161 insertions(+), 33 deletions(-)
             create mode 100755 tool/ln_sr.rb

commit c5a0856b4b34ecd2f5be070d454dbd3fc25d9529
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 14:52:23 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 14:52:23 +0900

    merge revision(s) ed8c21bbd5071b52d0d0612eadbdad8fe192e974:

            Ensure symlinks to bundled gem with exts have parent dir

            When configuring with `--disable-rpath` and `--static-linked-ext` (e.g.
            building for WASI), `extmk.rb` doesn't build exts under bundled gems,
            and `.bundle/gems/#{gemname}-#{ver}` are not created due to no call of
            `extmake`.
            b2491783986084770f6f97552f27b868622730cf starts creating symlink at
            `.bundle/gems/#{gemname}-#{ver}/lib`, but the parent dir is not created,
            so configuration aginst debug and rbs gems were failed.
            ---
             ext/extmk.rb | 1 +
             1 file changed, 1 insertion(+)

commit 93d1a2e94cf27744b725dd4a90e3044aaffc3c4d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 14:51:24 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 14:51:24 +0900

    merge revision(s) dcbb94d5b9b4a7d0bfde5ba9a5da1ada643a31b7:

            Move timestamps directory for bundled gems

            ---
             ext/extmk.rb | 5 ++++-
             1 file changed, 4 insertions(+), 1 deletion(-)

commit 130ee27382b4b020e9d0e5bee9ddd2a1640f3887
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 14:17:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 14:17:30 +0900

    merge revision(s) b291c972fa36e05107d13eea25cc445db4b4bec3:

            Use built bundled gems in test-bundled-gems

            ---
             tool/test-bundled-gems.rb | 49 ++++++++++++++++++++++++-----------------------
             1 file changed, 25 insertions(+), 24 deletions(-)

commit eb815dfd9788c85251c7385dd09f9fab35e7e1b9
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 14:16:19 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 14:16:19 +0900

    merge revision(s) e0a7e5e13141a06103673b9d4ff21ca864ec38f9:

            Kill bundled gem tests when interrupted

            ---
             common.mk                 |  2 +-
             tool/test-bundled-gems.rb | 12 ++++++++++--
             2 files changed, 11 insertions(+), 3 deletions(-)

commit 3914581213e3aea138b02941b41e62c15461af27
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 14:01:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 14:01:57 +0900

    merge revision(s) 7f1ca666424849134990d022266bcd4d6636465f:

            Fallback PKG_CONFIG to the configured pkg-config always

            ---
             lib/mkmf.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit ac0c771d03573a4e99aff033599cb9f050fea4ff
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 13:41:35 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 13:41:35 +0900

    merge revision(s) 019cbded90ade76fdb87d02bd4d444724429fc92:

            mkmf: Add a configure option to set verbose mode (V=1 or 0) in
             mkmf.rb.

            Note this change is only for `configure.ac`, not for Windows using
            `win32/configure.bat`.

            ```
            $ ./configure --help | grep mkmf
              --enable-mkmf-verbose   enable verbose in mkmf
            ```

            Run the following command to enable the mkmf verbose mode.

            ```
            $ ./configure --enable-mkmf-verbose
            $ grep MKMF_VERBOSE config.status
            S["MKMF_VERBOSE"]="1"
            ```

            In this mkmf verbose mode, when compiling a native extension, the
            `rake compile` prints the compiling commands such as
            "gcc -I. <...> path/to/file" instead of "compiling path/to/file".

            ```
            $ git clone https://github.com/deivid-rodriguez/byebug.git
            $ cd byebug
            $ bundle install --standalone
            $ bundle exec rake compile
            ...
            gcc -I. <...> path/to/file
            ...
            ```
            ---
             configure.ac | 7 +++++++
             lib/mkmf.rb  | 3 ++-
             2 files changed, 9 insertions(+), 1 deletion(-)

commit 1ccdd9ee5773b34867fce8c3796e046ee6b2b9f5
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 13:41:00 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 13:41:00 +0900

    merge revision(s) bdb7345ce96c641796909abc2dbdac0d4400ca41:

            Use compiled instead of complied

            Capitalize creates
            ---
             lib/mkmf.rb | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

commit 82b6b9c5124c446c64a5cca144abdcf933e7774f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 13:39:45 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 13:39:45 +0900

    merge revision(s) 6946263a2994257c6240e52a365700dc573c7ed4:

            [DOC] make internally used classes/methods nodoc

            Empty class documents are generated even with `:stopdoc:`.
            ---
             lib/mkmf.rb | 18 ++++++------------
             1 file changed, 6 insertions(+), 12 deletions(-)

commit e574190310c033ae807399e4197b0512389cbd65
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 13:38:46 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 13:38:46 +0900

    merge revision(s) 7672f6a42390a1a421fb0633e6810a92df7dad7a:

            mkmf: unify duplicate code in pkg_config

            ---
             lib/mkmf.rb | 11 +++--------
             1 file changed, 3 insertions(+), 8 deletions(-)

commit 5d4bfaccabe66d89460739ee682f1f78698c93a3
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 13:36:03 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 13:36:03 +0900

    merge revision(s) ab3cb29bd9bff9c16cfb9d19cc02026998282c12:

            Avoid defining the same test class in multiple files

            Should fix issues with parallel testing sometimes not running all
            tests.

            This should be viewed skipping whitespace changes.

            Fixes [Bug #18731]
            ---
             test/-ext-/bignum/test_big2str.rb        |  38 +-
             test/-ext-/bignum/test_bigzero.rb        |  20 +-
             test/-ext-/bignum/test_div.rb            |  38 +-
             test/-ext-/bignum/test_mul.rb            | 260 ++++++------
             test/-ext-/bignum/test_pack.rb           | 653 +++++++++++++++----------------
             test/-ext-/bignum/test_str2big.rb        |  52 ++-
             test/-ext-/funcall/test_funcall.rb       |  11 -
             test/-ext-/funcall/test_passing_block.rb |   5 +
             test/date/test_date_ractor.rb            |   2 +-
             test/fileutils/clobber.rb                |   5 +-
             test/fileutils/test_dryrun.rb            |   2 +-
             test/fileutils/test_nowrite.rb           |   2 +-
             test/fileutils/test_verbose.rb           |   2 +-
             test/fileutils/visibility_tests.rb       |   5 +-
             test/mkmf/base.rb                        | 225 ++++++-----
             test/mkmf/test_config.rb                 |  16 +-
             test/mkmf/test_constant.rb               |  56 ++-
             test/mkmf/test_convertible.rb            |  48 ++-
             test/mkmf/test_egrep_cpp.rb              |  14 +-
             test/mkmf/test_find_executable.rb        |  82 ++--
             test/mkmf/test_flags.rb                  |  92 +++--
             test/mkmf/test_framework.rb              |  70 ++--
             test/mkmf/test_have_func.rb              |  18 +-
             test/mkmf/test_have_library.rb           |  84 ++--
             test/mkmf/test_have_macro.rb             |  46 ++-
             test/mkmf/test_install.rb                |  38 +-
             test/mkmf/test_libs.rb                   | 156 ++++----
             test/mkmf/test_mkmf.rb                   |  14 +-
             test/mkmf/test_pkg_config.rb             |  98 +++--
             test/mkmf/test_signedness.rb             |  38 +-
             test/mkmf/test_sizeof.rb                 |  74 ++--
             test/optparse/test_acceptable.rb         |   2 +-
             test/optparse/test_autoconf.rb           |   4 +-
             test/optparse/test_bash_completion.rb    |   4 +-
             test/optparse/test_cclass.rb             |   2 +-
             test/optparse/test_did_you_mean.rb       |   2 +-
             test/optparse/test_getopts.rb            |   4 +-
             test/optparse/test_kwargs.rb             |   4 +-
             test/optparse/test_noarg.rb              |   6 +-
             test/optparse/test_optarg.rb             |   2 +-
             test/optparse/test_placearg.rb           |   2 +-
             test/optparse/test_reqarg.rb             |  10 +-
             test/optparse/test_summary.rb            |   2 +-
             test/optparse/test_zsh_completion.rb     |   4 +-
             test/ruby/enc/test_emoji_breaks.rb       | 207 +++++-----
             test/ruby/enc/test_grapheme_breaks.rb    | 115 +++---
             test/ruby/test_inlinecache.rb            |   2 +-
             47 files changed, 1280 insertions(+), 1356 deletions(-)
             delete mode 100644 test/-ext-/funcall/test_funcall.rb

commit 83ffa0d8e16cd829dc033d1d567353243845d86a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 13:34:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 13:34:02 +0900

    merge revision(s) acbc2bdd3030bef997919ce56c5b120cc5e91e8f:

            Update the test for [Feature #18615]

            ---
             test/mkmf/test_flags.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit fa5b7185b5e20752384961c8abd2d51e8622f975
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 13:33:48 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 13:33:48 +0900

    merge revision(s) 329c89bb42bb44467588afc1d41d9f99172dfeb5:

            Make implicit function declaration error [Feature #18615]

            Enable `-Werror=implicit-function-declaration` by default for
            building C extensions for early failures.
            ---
             lib/mkmf.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit d07fc4c4553bbacddeafc0108b21f2aec074b5ba
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 12:40:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 12:40:06 +0900

    merge revision(s) b90e56e6243f4e6567991bfd2375e1f58b1414a0:

            mkmf: pkg_config accepts multiple options

            ---
             lib/mkmf.rb                  | 48 +++++++++++++++++++++++---------------------
             test/mkmf/test_pkg_config.rb |  7 +++++++
             2 files changed, 32 insertions(+), 23 deletions(-)

commit 917df81f2ea5d338b5cc036e97b8f48bf3f8b528
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 12:38:29 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 12:38:29 +0900

    merge revision(s) 24c7e75ded461446e7c8e83bbceecccf7bcb4d0e:

            test: backfill coverage for MakeMakefile.pkg_config

            ---
             test/mkmf/test_pkg_config.rb | 61 ++++++++++++++++++++++++++++++++++++++++++++
             1 file changed, 61 insertions(+)
             create mode 100644 test/mkmf/test_pkg_config.rb

commit e0084d001b52407505b8cb80bed75ea5b0dcba35
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-21 12:35:00 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-21 12:35:00 +0900

    merge revision(s) 2304cfa4c08a347f4df4915f88fb062cb12e4eeb:

            Document MakeMakefile#append_cflags

            This method is at least 7 years old and is widely used in the wild.
            Since we need to support it, let's document it to make it discoverable.
            Add docs and move it out of the `# :stopdoc:` zone.
            ---
             lib/mkmf.rb | 25 +++++++++++++++----------
             1 file changed, 15 insertions(+), 10 deletions(-)

commit ecc6a717a4e6c808af96971ceb71224df6948bcf
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-20 23:06:47 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-20 23:06:47 +0900

    merge revision(s) 2d57447ae80e0b0895d6d22d606391b48516ba93:

            Fix missing replacement in 1f91dcdab3b

            ---
             template/Makefile.in | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 4bb62ee57285da427d73ba30e7d76f0f377c9936
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-20 21:33:39 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-20 21:33:39 +0900

    merge revision(s) 6a8f1a9e5cd1c9c2b3c6925d8d3fa76a29dabf73:

            Copy from bundled gem source for test

            ---
             common.mk          | 13 +++++++----
             defs/gmake.mk      |  4 ++++
             tool/gem-unpack.rb | 63 +++++++++++++++++++++++++++++++++++-------------------
             3 files changed, 54 insertions(+), 26 deletions(-)

commit 46c2bf373d2665148f5004186209fee15c96f9b6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-20 21:22:04 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-20 21:22:04 +0900

    merge revision(s) 87d8d25796df3865b5a0c9069c604e475a28027f:

            Use configured GIT

            ---
             common.mk     |  4 ++--
             defs/gmake.mk | 68 +++++++++++++++++++++++++++++------------------------------
             2 files changed, 36 insertions(+), 36 deletions(-)

commit 19ef027d77a2ef73e1a4cb567e050b4e23ea0592
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-20 21:18:27 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-20 21:18:27 +0900

    merge revision(s) abc4a46046c326263683a8b3611775c2ddd56a71:

            Get rid of building main again when test-bundled-gems

            ---
             .github/workflows/ubuntu.yml      | 1 +
             .github/workflows/yjit-ubuntu.yml | 1 +
             common.mk                         | 3 ++-
             defs/gmake.mk                     | 2 +-
             4 files changed, 5 insertions(+), 2 deletions(-)

commit 5932b426bc2edc27195d936152ec5a726405ec9e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-20 21:16:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-20 21:16:32 +0900

    merge revision(s) 071653ecd79287661c795400797a5402c4322129:

            Run the prerequisites of test-bundled-gems in order

            ---
             common.mk     | 6 +++++-
             defs/gmake.mk | 7 ++++++-
             2 files changed, 11 insertions(+), 2 deletions(-)

commit 72e9097d37f6bab42eeeb6c14b5c0b1f564254cf
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-20 20:30:28 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-20 20:30:28 +0900

    merge revision(s) 4f1e0bfacd93c28bff549e2f3603c3b4942429a3:

            Followed up CVE-2022-39253 for bundler examples

            ---
             spec/bundler/cache/git_spec.rb           | 3 +++
             spec/bundler/install/gemfile/git_spec.rb | 9 +++++++++
             spec/bundler/update/git_spec.rb          | 3 +++
             3 files changed, 15 insertions(+)

commit fbf4bec4bcb39a6f1c4a0d0008876c6ec813c2ce
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-20 20:30:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-20 20:30:06 +0900

    merge revision(s) dae843f6b7502f921a7e66f39e3714a39d860181,86096a91d55f72620e0f8ca8634da5fa342dc35b:

            Bypass git submodule add/update with git config
             protocol.file.allow=always option.

            Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>
            ---
             test/rubygems/test_gem_source_git.rb | 5 +++++
             1 file changed, 5 insertions(+)

            [rubygems/rubygems] Use [] instead of double-quotes

            ---
             test/rubygems/test_gem_source_git.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 1db6249c66291ad2464f89768d24d850dbf98901
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-19 22:20:49 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-19 22:20:49 +0900

    merge revision(s) 1f91dcdab3b530dde93fa29fba8bf60683cd8056:

            Define BOOTSTRAPRUBY from HAVE_BASERUBY

            ---
             common.mk            | 1 +
             configure.ac         | 8 --------
             template/Makefile.in | 7 +++++--
             win32/Makefile.sub   | 6 ++++--
             4 files changed, 10 insertions(+), 12 deletions(-)

commit 3e05dff67cfa734eff18f0edf826ab2876b210b4
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-18 22:50:29 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-18 22:50:29 +0900

    merge revision(s) 6a43245e6cda89eddd105f5a6e0182a7229657af:

            Use BOOTSTRAPRUBY_COMMAND instead of fake.rb directly

            ---
             common.mk | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 671811a89d6e9f71c7c06117e6800cda219e0e85
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-18 22:27:38 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-18 22:27:38 +0900

    merge revision(s) d8f81ffdff668b457339885c15d7cee785ad38be:

            builtin.c includes mini_builtin.c when cross-compiling

            ---
             common.mk | 3 +++
             1 file changed, 3 insertions(+)

commit 75539c2d1ec42e938ebbcc70186a0c67c5b48753
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-18 21:50:27 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-18 21:50:27 +0900

    merge revision(s) 85a483169f8381bec08ff2c9a9fc66167fc8a84a:

            Use cross compiling settings as fake.rb for snapshots

            ---
             tool/make-snapshot | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 5f8c65494985f1afaf0f8d0e4dbb06acbd87da53
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-18 21:48:34 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-18 21:48:34 +0900

    merge revision(s) 76664905a589416739a13241e7b8535d78984723:

            Ignore fake.rb for snapshot

            ---
             common.mk | 6 +++---
             1 file changed, 3 insertions(+), 3 deletions(-)

commit c65bdad10f9242eca8aba01669aa7d97c9839550
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-18 21:47:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-18 21:47:20 +0900

    merge revision(s) 45004bba6b4fa22429b1c45f13444a894874c41e:

            fake.rb needs id.h

            ---
             common.mk | 3 ++-
             1 file changed, 2 insertions(+), 1 deletion(-)

commit 09c8604be8accede96c5aaa59d783ef4a34a66bf
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-18 21:46:33 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-18 21:46:33 +0900

    merge revision(s) 2767cb282531be10c6393d3d7c48fcdd2935ca4d:

            Now fake.rb is needed to prepare sources

            ---
             tool/make-snapshot | 1 +
             1 file changed, 1 insertion(+)

commit 9b1cf2c258f11b2931e2c5c34924e72a502618d4
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-18 21:46:18 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-18 21:46:18 +0900

    merge revision(s) 762fca9b12b9cfb0159404c95ee4275100169c17:

            Prefer `File` class methods to write a string

            ---
             tool/make-snapshot | 23 ++++++++++-------------
             1 file changed, 10 insertions(+), 13 deletions(-)

commit fbebe4936543af93a2e04893fe2f95cabaff342e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-18 21:44:27 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-18 21:44:27 +0900

    merge revision(s) a01271c1c46079cb6f7f32051f1253cf3d9bca6b:

            BOOTSTRAPRUBY needs fake.rb when cross-compiling

            ---
             configure.ac | 1 +
             1 file changed, 1 insertion(+)

commit 8e74bfb641096f39f8eb22961f7aadf89ab741cf
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-18 21:42:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-18 21:42:37 +0900

    merge revision(s) 7c67d0fd79a3cffe857587fa3cf576b611023840:

            Make sources by BASERUBY if available instead of miniruby

            ---
             common.mk             | 25 +++++++++++++++----------
             configure.ac          |  6 +++++-
             cygwin/GNUmakefile.in |  4 ++--
             template/Makefile.in  |  2 +-
             win32/Makefile.sub    | 10 ++++++++--
             5 files changed, 31 insertions(+), 16 deletions(-)

commit 0bdf9c4e01345867159aa042b2540be710f8ec5e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-18 21:40:12 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-18 21:40:12 +0900

    merge revision(s) 21a5da3c4c803987c48bc9ca588948c50715631a:

            Check if MSys shell can run a command with a drive letter

            ---
             configure.ac | 10 ++++++++--
             1 file changed, 8 insertions(+), 2 deletions(-)

commit 5e901758edfe8494ed40167ba2f301e4ca04d670
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-18 21:27:47 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-18 21:27:47 +0900

    merge revision(s) 26054c74619d36b2781e872fad15a1a0bfab1be1:

            Fix paths of exts.mk to clean

            exts.mk files are one level under the top of extension directories.
            ---
             template/exts.mk.tmpl | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit b4f8f4ce85c8adcba11931422b065aac6f06f50b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-18 21:27:33 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-18 21:27:33 +0900

    merge revision(s) 77f3f8a1d4f45d06df6cfea2bac3a67867c19efb:

            exts.mk.tmpl: propagate MINIRUBY to enc.mk even though invoking from
             exts.mk

            This is another attempt to fix out-of-src build with
            --with-static-linked-ext. The first attempt was
            4f1888bda70981d9f5b1bf55ab692e0ce18e79f4 but reverted because it broke
            out-of-src build from pre-generated sources via `make dist`.
            This patch fixes the second trans C source gen, mentioned in the
            previous commit message, by passing MINIRUBY as well as when invoking
            from common.mk
            ---
             common.mk             | 2 +-
             template/exts.mk.tmpl | 2 +-
             2 files changed, 2 insertions(+), 2 deletions(-)

commit 9fc7df7504f41a7f370e62a004c3fc0abc439295
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-16 20:39:46 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-16 20:39:46 +0900

    merge revision(s) 464f73a5f0c1042bfefdd367b330cbdcafffca95:

            Do not load library files from repository only for test

            What we want to test should be the bundled and to be installed files,
            but not the upstream.
            ---
             tool/test-bundled-gems.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit c1129491bbf072862d10caa5b97acaa59437ecf3
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-16 19:37:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-16 19:37:57 +0900

    merge revision(s) 64cff780051adf95a0f1799baddec98ae23e8add:

            `Gem.unpack` extracts gems so able to execute

            Creates simple bin stubs to load the extracted executable files.
            After only extracted under `gems` directory, the gems are considered
            installed but the executable scripts are not found.
            Also the second argument is now the parent of the previous second and
            third arguments.
            ---
             common.mk          |  6 ++----
             defs/gmake.mk      |  3 +--
             tool/gem-unpack.rb | 30 +++++++++++++++++++-----------
             3 files changed, 22 insertions(+), 17 deletions(-)

commit 174594cf77bed6c3899af4ef14f6c7d257e6461d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-16 19:33:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-16 19:33:02 +0900

    merge revision(s) d20886dd225e07fe14347398c2c0913f3e11d22a:

            Create build-only gemspec files only if having an extension

            ---
             tool/gem-unpack.rb | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

commit e7b557cefe870a7d83b6ac7cf6edf1997afcc29a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-16 16:46:29 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-16 16:46:29 +0900

    merge revision(s) 32d1ce96e09773e809d575c17b916012d88d6ffc:

            Fix race conditions when cleaning extensions

            Clean built directories by `make distclean`, and then clean leftover
            makefiles for skipped extensions.
            ---
             template/Makefile.in | 4 ++++
             1 file changed, 4 insertions(+)

commit ae6f46db35ed4327370001be267cc1edfb891816
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-16 16:46:07 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-16 16:46:07 +0900

    merge revision(s) 0c9803b0fdfd17981bd9f59767adab0207c3a74d:

            The "gems" build directory was rename as ".bundle"

            ---
             common.mk            | 12 ++++++------
             template/Makefile.in | 10 +++++-----
             2 files changed, 11 insertions(+), 11 deletions(-)

commit 2a0a9d56d4f927b597cd5ea2d1d5d0772e48970d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-16 16:41:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-16 16:41:57 +0900

    merge revision(s) 21f006f5f7c161fd3857f69186e810f1958bd7f0:

            Retrieve previously configured macros also other than `extensions`

            ---
             template/exts.mk.tmpl | 1 -
             1 file changed, 1 deletion(-)

commit ed960c6750d21b4c473044d9516e3a9eb2d335d0
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-16 16:31:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-16 16:31:37 +0900

    merge revision(s) d7afaf21f2edfac8a606891868a3c4a7025267bd:

            Move the target directory of bundled gems like as rubygems

            ---
             ext/extmk.rb | 6 +++++-
             1 file changed, 5 insertions(+), 1 deletion(-)

commit 363dc5d131398a2c62717fb861e1cdb13ca30212
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-16 16:31:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-16 16:31:02 +0900

    merge revision(s) 17ce0b9b846a065065008b5fb2e9f8ad13058fa1:

            Retrieve configured gems info

            ---
             template/configure-ext.mk.tmpl | 2 +-
             template/exts.mk.tmpl          | 4 ++--
             2 files changed, 3 insertions(+), 3 deletions(-)

commit e3abdccca020496b047769e506db8da7342ea15f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-16 16:29:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-16 16:29:02 +0900

    merge revision(s) db3d111c1d1e90b400f1e737ded6a4e4bdf2cec8:

            Bundled gems are expanded under `.bundle/gems` now

            ---
             ext/extmk.rb          | 13 +++++++------
             template/exts.mk.tmpl |  2 +-
             2 files changed, 8 insertions(+), 7 deletions(-)

commit 667aa81219ca080c0a4b9f97d29bb3221bd08a33
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-16 13:40:41 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-16 13:40:41 +0900

    merge revision(s) ee6cc2502664ac46edc61868d8954b626bb48e53:

            Remove wrong dollar

            ---
             configure.ac | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 802671cdd43ed15eda0a30c187c6a4ce129dfbf9
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-15 17:32:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-15 17:32:21 +0900

    merge revision(s) 5e554d30ba747ad1b59335efaa63c7e3c94bfad0:

            Upgrade zlib_version on AppVeyor

            They removed https://zlib.net/zlib1212.zip because
            https://zlib.net/zlib1213.zip was released :thinking_face:

            Fix CI failures like:
            https://ci.appveyor.com/project/ruby/ruby/builds/45064876/job/bb9biogolh0u2595
            ---
             .appveyor.yml | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 50496fb1788ea5d8c98d7946ed567c071a451d12
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-15 16:35:48 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-15 16:35:48 +0900

    merge revision(s) 9d900620cafc379f527ee04a338f3a7f5daf6962:

            Set `GEM_PATH` environment variable in runruby.rb

            ---
             tool/runruby.rb | 6 ++++++
             1 file changed, 6 insertions(+)

commit cc745f2da175d1658aa2923d65a964848e96d001
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-15 16:34:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-15 16:34:32 +0900

    merge revision(s) 416cba90c1610f54dafd91234de9ec74d73ae22c:

            Try to install also gemspec files under gem directories

            Gemspec files having extension libraries are placed under each gem
            directories now.
            ---
             tool/rbinstall.rb | 5 ++++-
             1 file changed, 4 insertions(+), 1 deletion(-)

commit 95e996e3350484e7845c681593498d9031de1488
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-15 16:33:45 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-15 16:33:45 +0900

    merge revision(s) 2d1032075a4654b8b54dde96424f299f7f29f9d6:

            Stop `build_extensions` when DESTDIR set

            Try to fix `make install without root privilege` failures on snapshot CIs.

            example: https://github.com/ruby/actions/actions/runs/2315349280
            ---
             tool/rbinstall.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit fa2ddb67c5a19d1c165fbba4102ca7a397fa50d5
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-15 16:33:24 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-15 16:33:24 +0900

    merge revision(s) 79fa27acc452c50ae47936880f91424e729fda72:

            rbinstall: Also do `Gem.ruby` patching for unpacked bundled gems

            Pointing `Gem.ruby` to the newly installed ruby gives mkmf the right
            inputs to build extensions in bundled gems. Previously, this patching
            was only done for compressed bundled gems.

            This patch also prevents `tool/fake.rb` from propagating to the child
            process running mkmf for the native extension. The way `tool/fake.rb`
            changes mkmf variables using `Kernel#trace_var` created spooky action at
            a distance which made debugging difficult.

            AppVeyor Windows CI started to fail starting with
            8a3663789c52ec5635194656af6b69d3d03120ee because it enabled extension
            building for bundled gems on mswin. This patch should address the CI
            failures.
            ---
             tool/rbinstall.rb | 8 +++++++-
             1 file changed, 7 insertions(+), 1 deletion(-)

commit d4dadf5d9baf2998b95550cb5bd7f55a4f11a729
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-15 16:32:46 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-15 16:32:46 +0900

    merge revision(s) 8a3663789c52ec5635194656af6b69d3d03120ee:

            Fix bundled gems installation when relative loading

            ---
             tool/rbinstall.rb | 10 +++++++---
             1 file changed, 7 insertions(+), 3 deletions(-)

commit 578f0313ed7e10d39242f2c7659dc24ae1953be6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-15 16:32:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-15 16:32:16 +0900

    merge revision(s) 7e4ac434b923739b540ce21cba307c4d0515d72e:

            Skip build extensions again on cross compiling too

            ---
             tool/rbinstall.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit d3f464094d9a1308a32d34faa9055fa86c916828
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-15 16:32:00 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-15 16:32:00 +0900

    merge revision(s) 3112475469e35b522448858d23ee1651532276e7:

            Skip build extensions again on mswin and mingw

            ---
             tool/rbinstall.rb | 3 +++
             1 file changed, 3 insertions(+)

commit 69f7bc8675ed467259a41312e2f62b3d578d2a10
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-15 16:31:40 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-15 16:31:40 +0900

    merge revision(s) 4246e102d49eae0bd1bca01fba53286ad8178d2a:

            Enabled to build extensions with the bundled gems again

            https://github.com/ruby/ruby/commit/cbb115213c42f15638ef119eb20c4d3106eb8b1a
            https://github.com/ruby/ruby/commit/5c1b76a3a55afeb07116bbd3492303c6b6cd890d
            ---
             tool/rbinstall.rb | 3 ---
             1 file changed, 3 deletions(-)

commit 47dc4037166354dc929b5759b0a1ed065f8d716f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-15 16:31:00 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-15 16:31:00 +0900

    merge revision(s) 5c1b76a3a55afeb07116bbd3492303c6b6cd890d:

            Install built gem extension binaries

            ---
             tool/rbinstall.rb | 56 ++++++++++++++++---------------------------------------
             1 file changed, 16 insertions(+), 40 deletions(-)

commit 21c876d3ca0980c23f55bea4e1fd0328de3395ae
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-15 16:27:31 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-15 16:27:31 +0900

    merge revision(s) b2491783986084770f6f97552f27b868622730cf:

            Install gems `lib` directory to build path

            ---
             ext/extmk.rb | 19 +++++++++++++++++++
             1 file changed, 19 insertions(+)

commit 2d26e45135af8b427d9ccc6d47082c21be8b9c74
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-15 16:26:46 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-15 16:26:46 +0900

    merge revision(s) a2c66f52f402cb58372e271226f3341065561e53:

            Make dependency-free gemspec files

            The default gems have not been installed yet in the build directory,
            bundled gems depending on them can not work.  As those dependencies
            should be usable there even without rubygems, make temporary gemspec
            files without the dependencies, and use them in the build directory.
            ---
             ext/extmk.rb       | 11 +++++++++++
             tool/gem-unpack.rb |  4 ++++
             2 files changed, 15 insertions(+)

commit 4a986a11e2b2d7037f1e95b0317aa012dc0ee5fb
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-15 16:25:52 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-15 16:25:52 +0900

    merge revision(s) e1a4e44f14482814a0540ae0a4b31d858ff56f53:

            Extract gemspec files to each gem directories

            Since extension libraries can not be built in the source directory,
            rubygems warns gems have extension libraries as the extensions are not
            built.  To order to suppress this warnings, extract such gemspec files
            under each gem directories instead of the common `specifications`
            directory.
            ---
             tool/gem-unpack.rb | 10 ++++++----
             1 file changed, 6 insertions(+), 4 deletions(-)

commit f2c28e90698d6d9e8321237d3510d1737fc166ca
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-15 16:25:26 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-15 16:25:26 +0900

    merge revision(s) bb0a22a8c05994396aa316c242ff8816d8d0a259:

            Obey spec file locations to rubygems

            ---
             common.mk          | 3 ++-
             defs/gmake.mk      | 2 +-
             tool/gem-unpack.rb | 5 +++--
             3 files changed, 6 insertions(+), 4 deletions(-)

commit ef7cf5304eeb1835d4bf50f0001f7fd889b630a7
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-15 16:15:49 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-15 16:15:49 +0900

    merge revision(s) 1150a54afe98171657869bd2eafd82fda59893b1:

            Use `File::PATH_SEPARATOR` for the portability

            ---
             tool/test-bundled-gems.rb | 6 +++---
             1 file changed, 3 insertions(+), 3 deletions(-)

commit 830fbb412b1c01f0a44b66a70b946d7e87feb6e5
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-15 15:40:47 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-15 15:40:47 +0900

    merge revision(s) 76bae60d9b967415c5930c2c5906e14c8362a6dd: [Backport #19038]

            [Bug #19038] Fix corruption of generic_iv_tbl when compacting

            When the generic_iv_tbl is resized up, rebuild_table performs
            allocations that can trigger GC. If autocompaction is enabled, then
            moved objects are removed from and inserted into the generic_iv_tbl.
            This may cause another call to rebuild_table to resize the
            generic_iv_tbl. When returning back to the original rebuild_table, some
            of the data may be stale, causing the generic_iv_tbl to be corrupted.

            This commit changes rebuild_table to only read data from the st_table
            after the allocations have completed.

            Co-Authored-By: Matt Valentine-House <matt@eightbitraptor.com>
            ---
             st.c | 15 ++++++++++-----
             1 file changed, 10 insertions(+), 5 deletions(-)

commit 994b505ffb0bf9eb795525199b47697412a98abb
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-10 17:51:34 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-10 17:51:34 +0900

    merge revision(s) 7f4345639b09395f2ab423d1cdac6f2ddf0707de:

            fake.rb: Set prefix to `$topdir`

            Not to refer outside the top build directory from rbconfig.
            ---
             tool/fake.rb | 1 +
             1 file changed, 1 insertion(+)

commit 02af7847439e4c7e0ebe80c14aa563df922b1442
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-09 14:56:28 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-09 14:56:59 +0900

    Revert "sync tool/rbinstall.rb to current master."

    This reverts commit bda0b8c09331111f38af98291c201595ce3a2872.

commit bda0b8c09331111f38af98291c201595ce3a2872
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-09 12:15:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-09 12:15:32 +0900

    sync tool/rbinstall.rb to current master.

commit a74626a8e4748021ca89cdd0986f765d34efb6c2
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-08 12:29:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-08 12:29:16 +0900

    bump patchlevel

commit d77e6e653d32fa6287286cc68300abc0d1a299da
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-10-06 15:43:48 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-08 12:27:30 +0900

    Merge RubyGems-3.3.23 and Bundler-2.3.23

commit d2f4cbf04215e536bcd06fde9cc7cec3b5566707
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-06 19:49:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-06 19:49:21 +0900

    merge revision(s) 5101671cbc008230cae7b5c2190b2f6938a19f74:

            Disable parallel built in test-bundled-gems

            ---
             common.mk                 | 2 +-
             tool/test-bundled-gems.rb | 2 ++
             2 files changed, 3 insertions(+), 1 deletion(-)

commit b9771836cbfaff77f25bdcfd7b6c7f1fcf2053b9
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-05 21:20:58 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-05 21:20:58 +0900

    update debug.gem commit hash to cease nightly packaging failures.

commit b0645e35db8b40b56526063e672b7a71ec3cdada
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-04 20:24:09 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-04 20:24:09 +0900

    update debug.gem commit hash to cease nightly packaging failures.

commit 263ae503650531b90653ab78124b6d2d513e06cc
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-03 19:52:35 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-03 19:52:35 +0900

    merge revision(s) b91f685a2615ef957210f5e3a50c0e8299c20c55: [Backport #18435]

            Mark struct METHOD->owner for the GC

            * Fixes https://github.com/ruby/ruby/commit/6b7d32a5e5
            * See [Bug #18729]
            ---
             proc.c | 2 ++
             1 file changed, 2 insertions(+)

commit 5c232257545ccdcf8e8b882ec4a85a03cd9fad2b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-01 20:32:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-01 20:32:21 +0900

    bump patchlevel

commit df1cf0a08b1c078ef37e8d2c1a2ac9b0c3fca8b3
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-09-29 15:40:22 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-01 20:29:30 +0900

    Re-enable example for Europe/Amsterdam pre-1970 time

      * https://github.com/ruby/spec/pull/939
      * https://github.com/ruby/ruby/pull/6393

commit 0872fe0973e1014cf5035e33b139dbd26b063af4
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-01 18:10:51 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-01 18:10:51 +0900

    bump patchlevel

commit 8ebaa174d8dc458edf85b1f8b50d033f4bff6106
  Author:     Yuta Saito <kateinoigakukun@gmail.com>
  AuthorDate: 2022-09-24 03:36:04 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-01 18:10:12 +0900

    Initialize Objective-C classes before fork() for macOS 13

    Since macOS 13, CFString family API used in
    `rb_str_append_normalized_ospath` may internally use Objective-C classes
    (`NSTaggedPointerString` and `NSPlaceholderMutableString`) for small strings.

    On the other hand, Objective-C classes should not be used for the first
    time in a `fork()`'ed but not `exec()`'ed process. Violations for this rule
    can result deadlock during class initialization, so Objective-C runtime
    conservatively crashes on such cases by default.

    Therefore, we need to use CFString API to initialize Objective-C classes
    used internally *before* `fork()`.

    For more details, see https://bugs.ruby-lang.org/issues/18912

commit bf92aace45ed7f2e5455cf0a2fdd4d1cfa9edd38
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-09-17 12:09:34 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-01 18:10:12 +0900

    [Bug #19005] dynamic_lookup linker option in external libraries

    The warning against `-undefined dynamic_lookup` is just a warning yet,
    and many gems seem to pay no attention to warnings.  Until it fails
    actually, keep it as a migration path, except for standard extension
    libraries and bundled extension gems.

commit 2244fc9aa7ef8e03ac966e59b581baa021106b46
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-09-13 23:56:34 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-01 18:10:12 +0900

    -undefined dynamic_lookup is obsolete

commit 9e739022ded433f189a575017d3936b79541f229
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-01 13:39:47 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-10-01 15:32:44 +0900

    merge revision(s) 94cea3e4d0a60326bd95be762819eed8ccd59ca6,aa53d69aa21c4dfa2a78a1cec5cb34e9697b3d30,6b7d32a5e54088b6b4014529bbf2b4b8c1a96029,c6319026caa6c8f0f569f80011e8502349a04b14,aa490f9442c32cd0e1e449ac817f410bd5924c8b: [Backport #18435]

            Fix {Method,UnboundMethod}#super_method for zsuper methods

            * We need to resolve the zsuper method first, and then look the super
              method of that.
            ---
             proc.c                                            | 25 ++++++++++++-----------
             spec/ruby/core/method/super_method_spec.rb        | 15 +++-----------
             spec/ruby/core/unboundmethod/super_method_spec.rb | 16 ++++++---------
             3 files changed, 22 insertions(+), 34 deletions(-)

            Add specs for {Method,UnboundMethod}#owner of a zsuper method

            ---
             spec/ruby/core/method/owner_spec.rb        | 6 ++++++
             spec/ruby/core/unboundmethod/owner_spec.rb | 7 +++++++
             2 files changed, 13 insertions(+)

            Resolve zsuper method during lookup but preserve owner separately

            * See https://bugs.ruby-lang.org/issues/18729#note-34
            * See [Bug #18729]
            ---
             proc.c                   | 109 +++++++++++++++++++++++++----------------------
             test/ruby/test_method.rb |  66 +++++++++++++++++++++++-----
             2 files changed, 114 insertions(+), 61 deletions(-)

            Extend tests for a zsuper method of which the method it resolved to
             has been removed

            ---
             test/ruby/test_method.rb | 41 +++++++++++++++++++++++++++++++++++++++++
             1 file changed, 41 insertions(+)

            Reduce diff to proc.c @ b0b9f7201acab05c2a3ad92c3043a1f01df3e17f

            * So it's easy to review https://github.com/ruby/ruby/pull/6242 +
              https://github.com/ruby/ruby/pull/6467 and there are less changes
              overall.
            ---
             proc.c                   | 76 ++++++++++++++++++------------------------------
             test/ruby/test_method.rb |  7 +++--
             2 files changed, 34 insertions(+), 49 deletions(-)

commit e46532feafadef252682794c941180df72483c19
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-25 21:24:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-25 21:24:30 +0900

    merge revision(s) cf7d07570f50ef9c16007019afcff11ba6500d70: [Backport #18938]

            Dump non-ASCII char as unsigned

            Non-ASCII code may be negative on platforms plain char is signed.
            ---
             ext/objspace/objspace_dump.c   |  2 +-
             test/objspace/test_objspace.rb | 15 +++++++++++++++
             2 files changed, 16 insertions(+), 1 deletion(-)

commit d1b36c827036765ab68c88ab4315a26a220d5f06
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-25 16:01:13 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-25 16:01:13 +0900

    merge revision(s) e2b47b832f53b2fd0626774a573a22c15a933c64,f512df73986c74e2f4bd65ca642879a0618da213,2e25b85a7e4268676fcdf17b5975c2fd60066ce1: [Backport #19014]

            configure.ac: Manage OPT_DIR better (#6367)

            * Check rpath flag earlier

            * Manage OPT_DIR at once
            ---
             configure.ac | 97 +++++++++++++++++++++++++++---------------------------------
             1 file changed, 43 insertions(+), 54 deletions(-)

            configure.ac: Add --with-gmp-dir (#6366)

            Add the `--with-gmp-dir` to specify the prefix directory of GMP.
            The`--without-gmp` option is preserved for convenience.  It can
            be used to force to reject using GMP even if the `--with-gmp-dir`
            option is specified.
            ---
             configure.ac | 14 +++++++++-----
             1 file changed, 9 insertions(+), 5 deletions(-)

            configure.ac: Apply suggestions from code review in #6366

            Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>
            ---
             configure.ac | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

commit a07e7ad6b0b9abc44d097ca600b0ff801d0d0a06
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-25 15:18:36 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-25 15:18:36 +0900

    merge revision(s) 70f69f85395f5735429cd45136d7de2742f08b72: [Backport #18941]

            [ruby/fileutils] Fix mkdir_p hanging on Windows when trying to create
             a file on a offline drive

            https://github.com/ruby/fileutils/commit/9cc6a082d7
            ---
             lib/fileutils.rb                 | 2 +-
             test/fileutils/test_fileutils.rb | 8 ++++++++
             2 files changed, 9 insertions(+), 1 deletion(-)

commit 89eab8e0bf34ed36f32c1f8c230790f8b23a356f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-25 13:46:29 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-25 13:46:29 +0900

    merge revision(s) 7f81f335478a3ca873f34e3bc0af6927819d3e84: [Backport #18734]

            Return `false` where sticky-bit is not provided [Bug #18734]

            ---
             file.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit e3607e687014da4f6347c462e7d11fb67000b733
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-25 13:45:46 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-25 13:45:46 +0900

    merge revision(s) a0040af6715d85f416f1282588974e151a8164eb: [Backport #18732]

            [Win32] Fix mode of character/pipe device stat [Bug #18732]

            ---
             test/ruby/test_file_exhaustive.rb | 33 ++++++++++++++++++++++++++++-----
             win32/win32.c                     | 22 ++++++++++++++++------
             2 files changed, 44 insertions(+), 11 deletions(-)

commit c356c31f77b2d7c7c7f40f5b19dbb0961ea5f803
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-25 13:00:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-25 13:00:25 +0900

    merge revision(s) 86d061294d3cc1656e18d0e1fd4b4f290da16944: [Backport #18928]

            [Bug #18928] Fix crash in WeakMap

            In wmap_live_p, if is_pointer_to_heap returns false, then the page is
            either in the tomb or has already been freed, so the object is dead. In
            this case, wmap_live_p should return false.
            ---
             gc.c | 21 +++++++++++----------
             1 file changed, 11 insertions(+), 10 deletions(-)

commit 13ee4b2c35bad0f893d5ed5a6fdca62da406f958
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-25 12:38:51 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-25 12:38:51 +0900

    merge revision(s) 68903df6f6fc548f3bf68fb09ee8b2495dcd28f0: [Backport #18922]

            [Bug #18922] Normalize time at 24:00:00 UTC

            ---
             test/ruby/test_time.rb |  2 ++
             time.c                 | 14 ++++++++++++++
             2 files changed, 16 insertions(+)

commit 720de2008ca06edb22e5ad7d1432fee4f2575e00
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-25 12:33:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-25 12:33:30 +0900

    merge revision(s) 65ae2bb2e045aa8b668d3c30515f5a6cb3eb68ad: [Backport #18902]

            Thread#value: handle threads killed by a fork

            [Bug #18902]

            When a thread is killed because we forked, the `value` if left
            to `Qundef`. Returning it woudl crash the VM.
            ---
             test/ruby/test_thread.rb | 14 ++++++++++++++
             thread.c                 |  4 ++++
             2 files changed, 18 insertions(+)

commit 2fb900e6a0cc5625b95495eed8890cd58c94e66f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-20 21:52:58 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-20 21:52:58 +0900

    merge revision(s) 035978d7be9bc3819f42f964fe6193d983cce63f,2e324b645e16e67c14de80ea34b1d61165045f22,b6a9e683917745df2822a611fce64df9ae8090a7:

            Pass job-server FDs to bundler tests

            ---
             common.mk | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

            Manage paths for bundler tests

            ---
             common.mk | 6 +++++-
             1 file changed, 5 insertions(+), 1 deletion(-)

            Add noarch-fake.rb target

            `yes-fake` depends on it when `arch=noarch` is given, but the rule to
            generate it from fake.rb.in is ignored now.
            ---
             common.mk | 3 +++
             1 file changed, 3 insertions(+)

commit 967f1251b464dbff4370a66fc41ce16727f0ea96
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-20 19:35:31 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-20 19:35:31 +0900

    merge revision(s) c8d94d2797f798e2666a057bb1940e1ffe41b717:

            Now test-bundler nees fake.rb

            ---
             common.mk | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 92b2bc517cd5a71d117ea0dffbe9796fc4e7adc0
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-20 12:54:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-20 12:55:27 +0900

    merge revision(s) 8794cc62899c6447fa4451489b9e308e2a890595,3ff53c8e04ecc91e0190de6d5950ecce2a2ea188:

            Tentatively put macOS CIs back with adding macOS 12

            ---
             .github/workflows/macos.yml | 99 +++++++++++++++++++++++++++++++++++++++++++++
             1 file changed, 99 insertions(+)
             create mode 100644 .github/workflows/macos.yml

            Remove macOS 10.15 from CI

            macOS 10.15 is deprecated on GitHub Actions and will have periodic
            brownouts. See actions/virtual-environments#5583.
            ---
             .github/workflows/macos.yml | 1 -
             1 file changed, 1 deletion(-)

commit afb5971031540d8b1306d94a61b3700a672baf60
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-09-16 16:06:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-17 18:08:09 +0900

    Merge RubyGems-3.3.22 and Bundler-2.3.22

commit b3969f769a40e09ce5307b58ac78fa732c398aad
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2022-09-08 23:10:09 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-17 15:59:38 +0900

    Merge openssl-3.0.1

    The changes can be found at:

      https://github.com/ruby/openssl/compare/v3.0.0...v3.0.1

commit 99d254d8b025fd952375ed15c345ecc1b806652a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-17 14:05:23 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-17 14:05:23 +0900

    merge revision(s) de51bbcb544651fb499dd4cc757a2bf6f3b439cf: [Backport #18816]

            Use VM Lock when mutating waiting threads list

            `rb_thread_wait_for_single_fd` needs to mutate the `waiting_fds` list
            that is stored on the VM.  We need to delete the FD from the list before
            returning, and deleting from the list requires a VM lock (because the
            list is a global).

            [Bug #18816] [ruby-core:108771]

            Co-Authored-By: Alan Wu <alanwu@ruby-lang.org>
            ---
             thread.c | 6 +++++-
             1 file changed, 5 insertions(+), 1 deletion(-)

commit 87463832195eac16e9248e2a4a048c07f09582df
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-16 22:25:00 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-16 22:25:00 +0900

    merge revision(s) a28e7871e54d7a87afbfd686291c500d71edb7cb:

            Update bundled_gems

            Try latest patch to avoid some race on Mac OS X.
            ---
             gems/bundled_gems | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 9581248c4a48432c8c48d6bbf03a044c8f8e1cdc
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-10 16:54:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-10 16:54:43 +0900

    merge revision(s) b7577b4d9e0fd92522fc30e10fe712e245adee8c:

            The tzdata 2022c removed Amsterdam Mean Time

            ---
             spec/ruby/core/time/shared/local.rb | 2 ++
             1 file changed, 2 insertions(+)

commit 4508901fbd8825cc8d9aaf535b5201ade17a8392
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-10 16:04:33 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-10 16:04:33 +0900

    merge revision(s) 261753249996d46e00c2549fff2527816bf387db: [Backport #18936]

            Free cached mark stack chunks when freeing objspace

            Cached mark stack chunks should also be freed when freeing objspace.
            ---
             gc.c | 21 +++++++++++++++++++--
             1 file changed, 19 insertions(+), 2 deletions(-)

commit 163947f4dc031bb5e619ae64ad4a6a02f8885717
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-10 16:00:29 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-10 16:00:29 +0900

    merge revision(s) db0e0dad1171456253ebd899e7e878823923d3d8: [Backport #18990]

            Fix unexpected "duplicated key name" error in paren-less one line
             pattern matching

            [Bug #18990]
            ---
             parse.y                            | 16 ++++++++++++----
             test/ruby/test_pattern_matching.rb | 12 ++++++++++++
             2 files changed, 24 insertions(+), 4 deletions(-)

commit c498b16aaa485312e26b0b2109a5950da4cbb7c5
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-04 16:55:13 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-04 16:55:13 +0900

    revision up for https://github.com/ruby/ruby/pull/6296

commit 1821b7596986bda917f4de175f9b299d0a699d9e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-08-29 17:42:49 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-04 16:53:31 +0900

    Backport https://github.com/ruby/ruby/pull/6193

    Co-authored-by: Yuta Saito <kateinoigakukun@gmail.com>

commit 6b8bf6ba5d1893b3c933c2de3ada1eb59a94b644
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-04 16:01:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-04 16:01:43 +0900

    merge revision(s) 6d3f447aecfb56f7d3edbdf9cc68e748e150d7d8: [Backport #18631]

            Fix multiplex backreferencs near end of string in regexp match

            Idea from Jirka Marsik.

            Fixes [Bug #18631]
            ---
             regexec.c                | 6 ++++--
             test/ruby/test_regexp.rb | 6 ++++++
             2 files changed, 10 insertions(+), 2 deletions(-)

commit 1cfc139f6d0cb80d6024b0c416976194929417cf
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-04 16:00:14 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-04 16:00:14 +0900

    merge revision(s) d8189ed23f02dd197453279aeee9be1785337d4f: [Backport #18670]

            Return only captured range in `MatchData` [Bug #18670]

            ---
             re.c                     | 2 +-
             test/ruby/test_regexp.rb | 1 +
             2 files changed, 2 insertions(+), 1 deletion(-)

commit 4d26cfb2fef809474c8e05bf46abea8f301b2f9a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-03 15:56:33 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-03 15:56:33 +0900

    revision up for https://github.com/ruby/ruby/pull/6125

commit 4a9a38c388ce421b3c63c45ac0f0fc509e906ace
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-08-26 15:31:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-03 15:54:07 +0900

    Bump typeprof version to 0.21.3

commit 5ae91c7f1b1702553030cb43a427abcaad9b1c95
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-08-26 15:07:22 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-03 15:54:07 +0900

    Bump rbs version to 2.6.0+

commit eed5970b6477910f11630458bb4649c0b94cd4fb
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-08-26 14:54:17 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-03 15:54:07 +0900

    Merge csv-3.2.5

commit cd0c2a67c482c441ac7f0a07c0f81573d6b6072f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-08-26 14:53:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-03 15:54:07 +0900

    Merge csv-3.2.4

commit c69fffe67d7ad9c1afc4799222e819e0617e11c0
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-08-25 10:49:13 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-03 15:54:07 +0900

    Merge csv-3.2.3

commit a9bf13a4dfaed27e485a8a3f3fd9abcd9fd163b2
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-08-25 10:50:40 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-03 15:54:07 +0900

    Merge RubyGems-3.3.21 and Bundler-2.3.21

commit 522b75f1b666051f86a3c8961fd4255e560c5020
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-08-22 11:50:00 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-03 15:54:07 +0900

    Merge RubyGems-3.3.20 and Bundler-2.3.20

commit 44c926f3a94346809c68574e0277dae3917992c6
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-08-22 11:49:38 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-03 15:54:07 +0900

    Merge RubyGems-3.3.19 and Bundler-2.3.19

commit 091878334780a9d6618ff83371fde39d85b635b5
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-08-22 11:49:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-03 15:54:07 +0900

    Merge RubyGems-3.3.18 and Bundler-2.3.18

commit 7ef68dd74af151a340a592869c28a0f78d2f11fb
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-07-13 14:45:18 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-03 15:54:07 +0900

    Merge RubyGems-3.3.17 and Bundler-2.3.17

commit a01f5ad1ec2455e97e27eb2758588ff5e63c4131
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-07-13 14:44:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-03 15:54:07 +0900

    Merge RubyGems-3.3.16 and Bundler-2.3.16

commit b9f6a09bd2127ea51612bd27bef5830831b48d4f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-07-13 14:37:17 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-03 15:54:07 +0900

    Merge RubyGems-3.3.15 and Bundler-2.3.15

commit d7862a5de43f7412ab41cdae6709c8a30b988621
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-07-13 14:36:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-03 15:54:07 +0900

    Merge RubyGems-3.3.14 and Bundler-2.3.14

commit ffd3d83ea8ccf111061a0f03036e5a093bb03674
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-03 15:18:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-03 15:18:43 +0900

    merge revision(s) 08b6aacc1a14440e0f1644a05238559c6c585e38: [Backport #18739]

            Fix the wrong index of the previous component [Bug #18739]

            ---
             parse.y | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 5473c1064d5e82d706b554f2fe5a5b41900f6b14
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-09-03 15:05:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-09-03 15:05:32 +0900

    merge revision(s) 8212aab81a77a2a91fb7c1681b4968171193b48f,209631a45f9682dedf718f4b4a140efe7d21a6fc: [Backport #18435]

            Make Object#method and Module#instance_method not skip ZSUPER methods

            Based on https://github.com/jeremyevans/ruby/commit/c95e7e5329140f640b6497905485761f3336d967

            Among other things, this fixes calling visibility methods (public?,
            protected?, and private?) on them.  It also fixes #owner to show the
            class the zsuper method entry is defined in, instead of the original
            class it references.

            For some backwards compatibility, adjust #parameters and #source_location,
            to show the parameters and source location of the method originally
            defined. Also have the parameters and source location still be shown
            by #inspect.

            Clarify documentation of {Method,UnboundMethod}#owner.

            Add tests based on the description of https://bugs.ruby-lang.org/issues/18435
            and based on https://github.com/ruby/ruby/pull/5356#issuecomment-1005298809

            Fixes [Bug #18435] [Bug #18729]

            Co-authored-by: Benoit Daloze <eregontp@gmail.com>
            ---
             proc.c                   | 63 +++++++++++++++++++++++++++++++++++-------------
             test/ruby/test_method.rb | 59 +++++++++++++++++++++++++++++++++++++++++----
             2 files changed, 100 insertions(+), 22 deletions(-)

            Consider resolved-through-zsuper methods equal for compatibility

            * Fixes https://bugs.ruby-lang.org/issues/18751
            ---
             proc.c                                           | 65 +++++++++++-------------
             spec/ruby/core/unboundmethod/equal_value_spec.rb | 37 ++++++++++++++
             test/ruby/test_method.rb                         | 18 +++++++
             3 files changed, 86 insertions(+), 34 deletions(-)

commit 9b9704f9dc152c02b5baf370cf62923b07cb6072
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-07-27 22:55:52 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-07-27 22:55:52 +0900

    merge revision(s) 456e1d1eaa9bb11adaed1acde488d7da3c88704b:

            Try the tag without "v" prefix to checkout upstream repositories

            ---
             gems/bundled_gems          | 4 ++--
             tool/fetch-bundled_gems.rb | 2 +-
             2 files changed, 3 insertions(+), 3 deletions(-)

commit 736fe48b18109962a15e36177f13c4bf462875b8
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-07-15 09:10:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-07-15 09:10:02 +0900

    Remove GitHub Actions bundled_gems workflow in stable branch.

commit ce1621b9d2abe56a042e0cad4a26d10389d51735
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-07-13 20:53:19 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-07-13 20:53:19 +0900

    Update bundled gem debug-1.6.1.

commit 94ed94bf4e8407f31a9fffb0f4abf1836be0744b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-07-13 12:32:26 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-07-13 12:32:26 +0900

    Update bundled gem debug-1.6.0.

commit 88cdd1a7460705bed5af6763378b47a12351aecf
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-06-20 18:48:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-06-20 18:49:11 +0900

    Revert "merge revision(s) 5c1b76a3a55afeb07116bbd3492303c6b6cd890d: [Backport #18373]"

    This reverts commit d56b2e8820efd40840443ce3a5d16cff32a090c7.

commit d56b2e8820efd40840443ce3a5d16cff32a090c7
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-06-18 16:37:46 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-06-18 16:37:46 +0900

    merge revision(s) 5c1b76a3a55afeb07116bbd3492303c6b6cd890d: [Backport #18373]

            Install built gem extension binaries

            ---
             tool/rbinstall.rb | 56 ++++++++++++++++---------------------------------------
             1 file changed, 16 insertions(+), 40 deletions(-)

commit 750d4dc3aff7c2fef25fe99f1b98327f68734c9a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-06-18 16:10:51 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-06-18 16:10:51 +0900

    merge revision(s) 3bb70a6924ddd83f90b508b5bbc4d5629b8a41c6: [Backport #18673]

            Fix using anonymous block in method accepting explicit keywords

            Record block ID before vtable_pop, so the incorrect one doesn't
            override it.

            Fixes [Bug #18673]
            ---
             parse.y                  |  1 +
             test/ruby/test_syntax.rb | 54 ++++++++++++++++++++++++++++++++++++++++++++++++
             2 files changed, 55 insertions(+)

commit 702f7c8417e2a47bd88ef72fd705c1739cd958de
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-06-18 16:05:31 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-06-18 16:05:31 +0900

    merge revision(s) 222203297966f312109e8eaa2520f2cf2f59c09d: [Backport #18672]

            Remove dependency on libcapstone

            We have received reports of build failures due to this configuration
            check modifying compile flags. Since only YJIT devs use this library
            we can remove it to make Ruby easier to build for users.

            See: https://github.com/rbenv/ruby-build/discussions/1933
            ---
             configure.ac | 9 ---------
             1 file changed, 9 deletions(-)

commit 607a20b000f83003958e92b68319e860094f44fc
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-06-18 15:58:15 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-06-18 15:58:15 +0900

    merge revision(s) 97426e15d721119738a548ecfa7232b1d027cd34: [Backport #18627]

            [Bug #18627] Fix crash when including module

            During lazy sweeping, the iclass could be a dead object that has not yet
            been swept. However, the chain of superclasses of the iclass could
            already have been swept (and become a new object), which would cause a
            crash when trying to read the object.
            ---
             class.c | 48 ++++++++++++++++++++++++++++++------------------
             1 file changed, 30 insertions(+), 18 deletions(-)

commit 9d11ddcf6ace6676cea7cac836b4302240e3efb4
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-06-18 15:14:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-06-18 15:14:43 +0900

    merge revision(s) 0c6e24d102e894a7211a596e6aa95828b1cf4406: [Backport #18600]

            Fix visibility of alias of zsuper methods

            This was broken by 71c746379d5872e250d90ae45c585760afaf9516.

            Fixes [Bug #18600]
            ---
             test/ruby/test_alias.rb | 10 ++++++++++
             vm_method.c             |  1 +
             2 files changed, 11 insertions(+)

commit c7bbed299493d0fe5323916b83dab04021bc570f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-05-17 11:26:18 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-18 10:02:42 +0900

    Merge RubyGems-3.3.13 and Bundler-2.3.13

commit 14e4055ab127b37e48d07ead34dcb8ffa8874a65
  Author:     MSP-Greg <Greg.mpls@gmail.com>
  AuthorDate: 2022-01-15 00:00:56 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-18 10:02:42 +0900

    [Actions] mingw - use ruby/setup-ruby@v1 again

commit 42355187df2e96c983b24c6797c2889068e92593
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-01-14 15:50:33 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-18 10:02:42 +0900

    Try previous ruby-setup-ruby

    The commits between db14f2dde9ceeaa8acbcd31884475a7ce97ae9d3 and
    11cc84264a91d42bc873f39d70678e44042322d2 seems breaking
    OpenSSL::TestConfig#test_s_parse_include.

commit 04d3a841781f6846f3297c38417961056295170a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-05-17 10:57:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-18 10:02:42 +0900

    Merge Psych-4.0.4

commit 86ca4b3fb404487345aed0a25ed5f038303d54f2
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-05-09 07:29:33 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-18 10:02:42 +0900

    Ignore rubyspec_temp fot Git

commit 719298051bce4d65f21f93b7ed579c9f3c225d98
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-04-28 17:48:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-18 10:02:42 +0900

    [rubygems/rubygems] Skip test for cargo builder

    https://github.com/rubygems/rubygems/commit/60ca4ad9c6

commit 7e580d4156ed4b62f5452bcc821d2ea60a65974c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-04-28 17:48:04 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-18 10:02:42 +0900

    [rubygems/rubygems] Move testing_ruby_repo into test helper

    https://github.com/rubygems/rubygems/commit/6590debe55

commit 2e291e3ffdea1cba747119ff58cf253f4c4a87c8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-05-02 19:42:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-18 10:02:42 +0900

    Merge RubyGems-3.3.12 and Bundler-2.3.12

commit 8ba584ff3c085251865c11c5d7deef0ddfc6d0ff
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-05-02 19:42:15 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-18 10:02:42 +0900

    Merge RubyGems-3.3.11 and Bundler-2.3.11

commit ec5dae0d816261719b0b2f9595c072701c7036e0
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-04-06 19:10:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-18 10:02:42 +0900

    Merge RubyGems-3.3.10 and Bundler-2.3.10

commit 1a0c76f4e1cb779f40986285ec931078835495ae
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-03-10 13:36:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-18 10:02:42 +0900

    Merge RubyGems-3.3.9 and Bundler-2.3.9

commit b61f3a9199adb771d785c948ceb8dac61e0fc77f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-03-10 13:32:31 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-18 10:02:42 +0900

    backport the latest version of sync_default_gems

commit c5432beecce5339ce3f5c20b990710d7f62de854
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-03-03 17:56:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-18 10:02:42 +0900

    Bump cgi version to 0.3.2

commit b5ef64a8a129919e035c4499e946c83b22ad0101
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-03-01 12:11:15 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-18 10:02:42 +0900

    Merge RubyGems-3.3.8 and Bundler-2.3.8

commit 1a6a608ae0dbd389b62fcfc95867418960800f5e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-02-28 19:21:52 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-18 10:02:42 +0900

    [ruby/securerandom] Bump up v0.2.0

    https://github.com/ruby/securerandom/commit/62ca2828f3

commit 81a8661ed10432a91c4564ceaa14698cb34c8ca0
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-05-18 10:01:46 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-18 10:01:46 +0900

    bump patchlevel

commit e87640cd9d3dfe2cad004224eb356ee406865c8a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-05-05 19:18:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-05 19:18:37 +0900

    merge revision(s) 1cbdedec895070df1df96d05370cf8da084ab6fa:

            [ruby/zlib] Mask checksums to lower 32bits

            Upper bits affect the result of `crc32` in zlib 1.2.12.

            https://github.com/ruby/zlib/commit/9ab6d04af1
            ---
             ext/zlib/zlib.c        | 12 +++++++++---
             test/zlib/test_zlib.rb |  2 ++
             2 files changed, 11 insertions(+), 3 deletions(-)

commit 5a578f10aef8c0935090ea8d4e66c7ad3094fc18
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-05-03 21:03:27 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-03 21:03:27 +0900

    merge revision(s) 44c44b9b4af14f42a0dc6df9287c45d9689847bb:

            Ignore warnings at reading debug info for now

            Something seems changed on FreeBSD 13.
            ---
             test/ruby/test_rubyoptions.rb | 1 +
             1 file changed, 1 insertion(+)

commit 6d8007fab4d085812ff3b738a919c3e0f93ef1c2
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-05-03 11:24:55 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-03 11:24:55 +0900

    merge revision(s) 17e09f033c4d3b786672ba16d2c5d935482a2fad,bfc697f1e26f1406c45ec7309ca0d4c0b5ecedd6:

            Skip three tests on FreeBSD 13

            Some tests that use signals frequently fail randomly on FreeBSD 13.
            Maybe something around signals has changed in FreeBSD 13.
            This change skips them tentatively.
            ---
             test/excludes/TestThread.rb        | 9 +++++++++
             test/excludes/TestThreadQueue.rb   | 9 +++++++++
             test/io/console/test_io_console.rb | 9 ++++++++-
             3 files changed, 26 insertions(+), 1 deletion(-)
             create mode 100644 test/excludes/TestThreadQueue.rb

            test/io/console/test_io_console.rb: parens needed

            ---
             test/io/console/test_io_console.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 27fbba91cf6aac8a52938afb1720be280447d76f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-05-03 11:23:33 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-03 11:23:33 +0900

    merge revision(s) b4fd0e0c73aac0cae23237743bbf7dc1b1315b6b,dfe7faa6b60464c184fede59f227341f6c57cc97:

            Exclude TestThread#test_signal_at_join on FreeBSD 13 for now [ci
             skip]

            ---
             test/excludes/TestThread.rb | 3 +++
             1 file changed, 3 insertions(+)

            exclude name must be Regexp or Symbol

            https://github.com/ruby/ruby/blob/fdf0f8d81487560f5837dc7e3888a96f7c2b4ec9/tool/lib/test/unit.rb#L1273-L1290
            ---
             test/excludes/TestThread.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 7bf1932d7f09fe26e20dbf30a724a52db93eb7fb
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-05-03 10:42:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-03 10:42:37 +0900

    merge revision(s) 63932ec33e720f006204adfd90ca67d364742b48:

            Bump github/codeql-action from 1 to 2

            Bumps [github/codeql-action](https://github.com/github/codeql-action) from 1 to 2.
            - [Release notes](https://github.com/github/codeql-action/releases)
            - [Changelog](https://github.com/github/codeql-action/blob/main/CHANGELOG.md)
            - [Commits](https://github.com/github/codeql-action/compare/v1...v2)

            ---
            updated-dependencies:
            - dependency-name: github/codeql-action
              dependency-type: direct:production
              update-type: version-update:semver-major
            ...

            Signed-off-by: dependabot[bot] <support@github.com>
            ---
             .github/workflows/codeql-analysis.yml | 6 +++---
             1 file changed, 3 insertions(+), 3 deletions(-)

commit 7202f862ab423bb0f45ebb62eeccc6fd520f435d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-05-01 18:44:55 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-01 18:44:55 +0900

    merge revision(s) 1ff174bfd17f80433f2cb9888eafd1c297efd2a5:

            [rubygems/rubygems] Fix a test for `bin/bundle update --bundler` to
             pass on ruby/ruby.

            Consider the case that the latest Bundler version on RubyGems is higher than
            the `system_bundler_version` (= `Bundler::VERSION`) in `make test-bundler` on
            ruby/ruby.

            See <https://bugs.ruby-lang.org/issues/18643>.

            https://github.com/rubygems/rubygems/commit/bfa2f72cfa
            ---
             spec/bundler/commands/binstubs_spec.rb | 5 ++++-
             1 file changed, 4 insertions(+), 1 deletion(-)

commit be7bcee858c5c05239893c3db115c3ff78c1c6ae
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-05-01 17:43:34 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-01 17:43:34 +0900

    remove bundled zlib patch file for mswin platform. It's already applied at zlib-1.2.12.

commit 8b02271e1ab97c5ac1444e79c0def6f49a99c534
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-05-01 17:40:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-01 17:40:43 +0900

    merge revision(s) 035b75c8f4097a48cde3cebc5db5e2efddc21546:

            Update zlib version to 1.2.12

            ---
             .appveyor.yml | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit e98c9c24f53d3866be2ddb941102188ccf6d8c3e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-05-01 16:39:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-01 16:39:21 +0900

    bump teeny version to 3.1.3.

commit 76b52b42a3453488e744937802cf154733aa1e6a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-05-01 16:36:46 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-05-01 16:37:00 +0900

    merge cf2bbcfff2985c116552967c7c4522f4630f2d18 partially.

    Add the relevant test code for 73f45e5e96ccc13a131f7c0122cf8600ce5b930f.

commit 4491bb740a9506d76391ac44bb2fe6e483fec952
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-04-12 20:11:15 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-04-12 20:11:15 +0900

    teenyup

commit 8d142ecff9af7d60728b8cfa9138e8623985c428
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-04-12 19:54:07 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-04-12 19:54:07 +0900

    Fix dtoa buffer overrun

commit 73f45e5e96ccc13a131f7c0122cf8600ce5b930f
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-04-12 19:53:43 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-04-12 19:53:43 +0900

    Just free compiled pattern if no space is used

commit 53f5fc4236a754ddf94b20dbb70ab63bd5109b18
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-02-18 18:42:25 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-02-18 18:42:25 +0900

    teenyup

commit 7fe0ebc4e7abd78501094cbb2d47918c8ff29f60
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-02-17 12:19:17 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-02-17 12:19:17 +0900

    merge revision(s) 496591de96b261b8789332c7f8b2bfbd17658955: [Backport #18578]

            st.c: Do not clear entries_bound when calling Hash#shift for empty
             hash

            tab->entries_bound is used to check if the bins are full in
            rebuild_table_if_necessary.

            Hash#shift against an empty hash assigned 0 to tab->entries_bound, but
            didn't clear the bins. Thus, the table is not rebuilt even when the bins
            are full. Attempting to add a new element into full-bin hash gets stuck.

            This change stops clearing tab->entries_bound in Hash#shift.
            [Bug #18578]
            ---
             st.c                   |  1 -
             test/ruby/test_hash.rb | 13 +++++++++++++
             2 files changed, 13 insertions(+), 1 deletion(-)

commit c8b5d7031ebd6bbc0f51582d51a4b47ccd9b0138
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-02-14 13:56:43 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-02-14 13:56:43 +0900

    Merge RubyGems-3.3.7 and Bundler-2.3.7 (#5543)

commit 36fa57fca0d5ecb317de8dba616a2225f3cac27a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-02-08 15:53:29 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-02-08 15:53:29 +0900

    Fixed path for ipaddr.rb (#5533)

commit 73159727ed88a8f739038984c847bb7313336450
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-02-08 00:14:27 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-02-08 00:14:27 +0900

    Merge ipaddr-1.2.4 (#5526)

    [Bug #18570]

commit 807dd0479267a067e8208a2053b446fa13a2e66f
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-02-07 20:08:50 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-02-07 20:08:50 +0900

    merge revision(s) c79d2e54748f52c5023b0a1ee441561df9826c17: [Backport #18562]

            Fix TAG_THROW through require [Bug #18562]

            Previously this was being incorrectly swapped with TAG_RAISE in the next
            line. This would end up checking the T_IMEMO throw_data to the exception
            handling (which calls Module#===). This happened to not break existing
            tests because Module#=== returned false when klass is NULL.

            This commit handles throw from require correctly by jumping to the tag
            retaining the TAG_THROW state.
            ---
             load.c                      |  2 +-
             test/ruby/test_exception.rb | 21 +++++++++++++++++++++
             2 files changed, 22 insertions(+), 1 deletion(-)

commit 86c8e15170484fe23b311e567717053f147ffd9c
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-02-07 19:58:46 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-02-07 19:58:46 +0900

    merge revision(s) 2a76440fac62b: [Backport #18501]

            [Bug #18501] Fire write barrier after hash has been written

            Before this change the write barrier was executed before the key and
            value were actually reachable via the Hash.  This could cause
            inconsistencies in object coloration which would lead to accidental
            collection of dup'd keys.

            Example:

            1. Object O is grey, Object P is white.
            2. Write barrier fires O -> P
            3. Write barrier does nothing
            4. Malloc happens, which starts GC
            5. GC colors O black
            6. P is written in to O (now we have O -> P reference)
            7. P is now accidentally treated as garbage
            ---
             hash.c | 20 +++++++++++++++-----
             1 file changed, 15 insertions(+), 5 deletions(-)

commit e54289bb632047b750f9c9371410d1adff2a740a
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-02-07 19:55:44 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-02-07 19:55:44 +0900

    merge revision(s) 67f4729: [Backport #18556]

            [Bug#18556] Fallback `MAP_ ANONYMOUS`

            Define `MAP_ANONYMOUS` to `MAP_ANON` if undefined on old systems.
            ---
             gc.c | 4 ++++
             1 file changed, 4 insertions(+)

commit 42c9ef769f210d88241a114395dd5ffc27b2fb87
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-02-03 08:04:57 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-02-03 08:04:57 +0900

    merge revision(s) 7ff1bf317887c0d7b21e91ad548d07b9f05c540c,e89d80702bd98a8276243a7fcaa2a158b3bfb659: [Backport #18516]

            An alias can suppress method redefinition warning

            ---
             test/ruby/test_alias.rb | 11 +++++++++++
             1 file changed, 11 insertions(+)

            Fix memory leak at the same named alias [Bug #18516]

            When aliasing a method to the same name method, set a separate bit
            flag on that method definition, instead of the reference count
            increment.  Although this kind of alias has no actual effect at
            runtime, is used as the hack to suppress the method re-definition
            warning.
            ---
             method.h                |  1 +
             test/ruby/test_alias.rb | 18 ++++++++++++++++++
             vm_method.c             |  9 ++++++++-
             3 files changed, 27 insertions(+), 1 deletion(-)

commit 7bef8ed183a336b040f051d7c2133b93364920c6
  Author:     git[bot] <svn-admin@ruby-lang.org>
  AuthorDate: 2022-02-02 17:53:26 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2022-02-02 17:53:26 +0900

    Update bundled gems list at 2022-02-02

commit 6794f8cf928ab8c009b301ec49a5a81e97e6eb2f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-02-02 16:57:34 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-02-02 16:57:34 +0900

    Merge pull request #5482 from hsbt/rubygems-3-3-bundler-2-3

    Merge RubyGems 3.3.x and Bundler 2.3.x

commit 270462103f7885e17d3c9d928d8fcabb4480bcbb
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-02-02 13:29:21 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-02-02 13:29:21 +0900

    Remove "Miscellaneous checks" from CI

    It is expected to use on master branch

commit cd4aae430da8303dac9f1be2d1e1b7ce1bc8a458
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-02-01 21:56:08 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-02-01 21:56:08 +0900

    merge revision(s) f27eb8148f5a72bbacfebfecc7de9305471bb5c9,d75f7078c831d45ab5ba2fae4fbb308d01a21e46,d5836db1b398a7936b0461b3011db66f6cc8c490: [Backport #18443]

            Sync io-console gem.

            ---
             ext/io/console/console.c           | 8 ++++++--
             test/io/console/test_io_console.rb | 8 ++++++++
             2 files changed, 14 insertions(+), 2 deletions(-)

            [ruby/io-console] bump up to 0.5.11

            https://github.com/ruby/io-console/commit/ad3805200c
            ---
             ext/io/console/io-console.gemspec | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            Fix `Leaked file descriptor: TestIO_Console#test_console_kw`

            ```
            Leaked file descriptor: TestIO_Console#test_console_kw: 10 : #<File:/dev/tty>
            ```
            ---
             test/io/console/test_io_console.rb | 4 +++-
             1 file changed, 3 insertions(+), 1 deletion(-)

commit 8177e3b8d323c3e5d897a8c8239be5f1e9f8f11d
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-02-01 21:53:43 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-02-01 21:53:43 +0900

    Revert "Fix console.c usage of `rb_io_wait`."

    This reverts commit aa3b2c81c8de2e70bd100e92436f15c03523eaf7.

commit 1f17463dec2ab1535096cb56005a840eae4fea5b
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-02-01 21:41:56 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-02-01 21:41:56 +0900

    merge revision(s) 6a6227e0168b059c3ed34c9f0ace2e5dc2364221: [Backport #18517]

            Shifting zero always results in zero [Bug #18517]

            ---
             numeric.c | 2 ++
             1 file changed, 2 insertions(+)

commit 1c426ddb25e2ccb169720e4f9894605596fe594d
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-01-31 19:22:28 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-01-31 19:22:28 +0900

    merge revision(s) 5c7af72304d0ad33cd3f21b24a4bc44e8acd5b2c,d650b17686d49c2ce8e6a87039861154e93d4621: [Backport #18497]

            Assuming EXIT_SUCCESS equals 0 is not portable

            ---
             test/ruby/test_fiber.rb | 6 +++---
             1 file changed, 3 insertions(+), 3 deletions(-)

            `rb_fiber_terminate` must not return [Bug #18497]

            In a forked process from a fiber, the fiber becomes the only
            fiber, `fiber_switch` does nothing as there is no other fibers,
            `rb_fiber_terminate` does not terminate the fiber.  In that case,
            reaches the end of `fiber_entry` finaly, which is declared as
            "COROUTINE" and should never return.
            ---
             cont.c                     |  3 ++-
             eval_intern.h              |  2 +-
             test/fiber/test_process.rb | 15 +++++++++++++++
             test/ruby/test_fiber.rb    |  5 +++++
             4 files changed, 23 insertions(+), 2 deletions(-)

commit 629b9da7dbdcaff04d6dde70f2431396f66e03e5
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-01-31 18:15:30 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-01-31 18:15:30 +0900

    merge revision(s) f3c77bd480834f2835fe6fef5c0475336248dbde: [Backport #18489]

            Fix the placeholder subclass entry skipping [Bug #18489]

            ---
             class.c                  | 3 +--
             test/ruby/test_module.rb | 9 +++++++++
             2 files changed, 10 insertions(+), 2 deletions(-)

commit 5b0c7b4ad00cd2ada282ea1aa03f0c1a75b0df77
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2021-12-27 13:08:35 +0900
  Commit:     NARUSE, Yui <nurse@users.noreply.github.com>
  CommitDate: 2022-01-31 15:35:55 +0900

    Prefer `wait_readable` rather than `IO.select`.

commit bdd3cf00370c0e56187f81159565f555c5eb9b6a
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2021-12-27 13:06:00 +0900
  Commit:     NARUSE, Yui <nurse@users.noreply.github.com>
  CommitDate: 2022-01-31 15:35:55 +0900

    Fix incorrect minimum read length.

commit aa3b2c81c8de2e70bd100e92436f15c03523eaf7
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2021-12-27 13:05:42 +0900
  Commit:     NARUSE, Yui <nurse@users.noreply.github.com>
  CommitDate: 2022-01-31 15:35:55 +0900

    Fix console.c usage of `rb_io_wait`.

commit 8e3bce0841497fc00ccdaf45f6583c25720a2d3f
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-01-31 11:16:52 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-01-31 11:16:52 +0900

    merge revision(s) ae5458f228a5477383e9c00425d85d50a3867817: [Backport #18475]

            thread.c: Convert TAG_BREAK to a normal exception at thread top-level

            [Bug #18475]
            ---
             test/ruby/test_enum.rb | 11 +++++++++++
             thread.c               |  3 +++
             2 files changed, 14 insertions(+)

commit abdd655afd6f3f36553e6bb0d6b3e3eac09ae977
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-01-31 11:15:50 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-01-31 11:15:50 +0900

    merge revision(s) 92630e2346a221fdfeaa484632938a06765bc6e5: [Backport #18468]

            [ruby/optparse] Fix links to the page directory files [Bug #18468]

            https://github.com/ruby/optparse/commit/dab72c543d
            ---
             doc/optparse/creates_option.rdoc | 4 ++--
             doc/optparse/option_params.rdoc  | 2 +-
             doc/optparse/tutorial.rdoc       | 4 ++--
             lib/optparse.rb                  | 4 ++--
             4 files changed, 7 insertions(+), 7 deletions(-)

commit 28ec24db4a8201fa624692cdc1cbef9b00489412
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-01-30 19:08:49 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-01-30 19:08:49 +0900

    merge revision(s) a79c59472df38297c246b27713c277f2edaefa7a: [Backport #18292]

            Allow include before calling Module#initialize

            This is to allow Module subclasses that include modules before
            calling super in the subclass's initialize.

            Remove rb_module_check_initializable from Module#initialize.
            Module#initialize only calls module_exec if a block is passed,
            it doesn't have other issues that would cause problems if
            called multiple times or with an already initialized module.

            Move initialization of super to Module#allocate, though I'm not
            sure it is required there.  However, it's needed to be removed
            from Module#initialize for this to work.

            Fixes [Bug #18292]
            ---
             class.c                  |  1 +
             object.c                 |  1 -
             test/ruby/test_module.rb | 10 ++++++++++
             3 files changed, 11 insertions(+), 1 deletion(-)

commit 1a1737530bff683041b8f45e7acac8c5c85c4163
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-01-30 19:07:47 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-01-30 19:07:47 +0900

    merge revision(s) c764e368bd9c0487e6cc97f8a62e0e0e99a0d7c5: [Backport #18469]

            Fix default --jit-max-cache in `ruby --help`

            changed at 028f1887c2bfa50dcfc1b623470d6ab1b880fdde
            ---
             ruby.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit e75246c287436621658bc2b8a5f999d8991e7d1d
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-01-30 19:06:55 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-01-30 19:06:55 +0900

    merge revision(s) 5917f49ad03cd3b2c13d3eea85c969a113b83bf8: [Backport #18436]

            Fix documentation for Dir.glob

            Dir.glob("*", File::FNM_DOTMATCH) no longer includes ".." in the
            returned array as of Ruby 3.1.

            Fixes [Bug #18436]
            ---
             dir.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit d3a2a3c5420fecfee54cbf3fbdd9287bc6c58f03
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-01-30 19:02:23 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-01-30 19:02:23 +0900

    merge revision(s) 9e0a91d0640600f2dfd7fc1d5fae6667019c9ca5: [Backport #18458]

            Don't segfault if Warning.warn is undefined

            Check that there is a method entry for the method before passing
            it to rb_method_entry_arity.

            Fixes [Bug #18458]
            ---
             error.c                     | 3 ++-
             test/ruby/test_exception.rb | 8 ++++++++
             2 files changed, 10 insertions(+), 1 deletion(-)

commit 2640161df5cf18d08ec86a0c1b913d4ee99e102a
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-01-30 19:01:49 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-01-30 19:01:49 +0900

    merge revision(s) 5414de4b6e4372af832e338f8eb7a9fe8de17c84: [Backport #18453]

            YJIT: Fix SP index with optarg and unordered kwarg

            Previously when we were calling a method with an optional argument and
            multiple keywords arguments which weren't in the order the receiver
            expected we would use the wrong SP index to rearrange them.

            Fixes Bug #18453
            ---
             bootstraptest/test_yjit.rb | 16 ++++++++++++++++
             yjit_codegen.c             |  7 +++++--
             2 files changed, 21 insertions(+), 2 deletions(-)

commit 20091ccad34904cb5ded13a8787f6662a8e2df68
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-01-30 18:57:52 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-01-30 19:01:11 +0900

    merge revision(s) 0dc7816c4350683ccd020f5759eee4914de0085d: [Backport #18434]

            Make RubyVM::AST.of work with code written in `-e` command-line
             option

            [Bug #18434]
            ---
             ast.c                 | 11 +++++++----
             test/ruby/test_ast.rb |  5 +++++
             2 files changed, 12 insertions(+), 4 deletions(-)

commit fb4df44d1670e9d25aef6b235a7281199a177edb
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-12-25 21:22:02 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-12-25 21:23:14 +0900

    Revert "Do not include external library sources into packages"

    This reverts commit a042043487eb4c7d39307b8e784ede1856455c3e.

    (cherry picked from commit 8325094177de60d365b2b5507488f0b53d11c736)

commit 1636612cc1c1f624dfcd9d4251b83d460abba1e9
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-12-25 20:59:55 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-12-25 21:06:10 +0900

    Prevent installing zlib library

    (cherry picked from commit 82c8acbcfd3197e19620dc6024d08c85ea99a05b)

commit 4bb3d4f6761d14e804a908481b7327821065c3c0
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-12-25 20:59:20 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-12-25 21:06:10 +0900

    Revert "make-snapshot: add -extlibs option"

    This reverts commit afa9d65d61857792508b1405835b07b78e24449c.
    It prevents installing libffi.

    (cherry picked from commit 1cc02078e503a18f6d1fcbd3e4d29c574895957d)

commit 0381df9a8f54afb52c7cb253b35524b0341b2a33
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-12-25 20:57:11 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-12-25 21:06:10 +0900

    fix tool/format-release

    Pass ruby directory path

    (cherry picked from commit 05faa36028a0a00788e2416a91e0bba21bd6f6ad)

commit e748dfb9a08935a13defb4646259ea4ca1480c53
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-12-25 00:18:25 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-12-25 18:55:32 +0900

    [ruby/io-console] bump up to 0.5.10

    https://github.com/ruby/io-console/commit/806c65e22b
    (cherry picked from commit 8247b193c0dd06db9ea56812954dda8fed89458d)

commit f5ddb96c49f6d542b96486e4ad332246ee62d01c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-12-25 00:18:04 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-12-25 18:55:32 +0900

    [ruby/io-console] No longer support dead versions

    https://github.com/ruby/io-console/commit/e9478509e9
    (cherry picked from commit 9368fa6c3073d5fe4380a5e84eb59f7cec2ce62c)

commit 80917ccbf88a938a1240848a0e1dba31d1ad1c91
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-12-25 18:24:39 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-12-25 18:55:32 +0900

    NEWS: mention Time.new argument error more

    Show an example of Time.new with perhaps unexpected results in
    earlier versions.

    (cherry picked from commit 14e550052be73ed35bfcbb0b6be696519ad7e092)

commit 12bbae2d4e8dc9cadeb69bf9a2459c510fa2bba5
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-12-25 17:09:19 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-12-25 18:39:24 +0900

    Suppress undef warnings for USE_RUBY_DEBUG_LOG

    (cherry picked from commit 975a6efd7ea144275d4774d18ff0f568c1a1dc97)

commit 17b48db00f6248fcd42ced7b398f1dcc36ec4dca
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-12-25 16:50:14 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-12-25 18:39:24 +0900

    Define fallback RUBY_DEVEL to suppress undef warnings

    (cherry picked from commit 566bdaef318674c416494786da551021afb1b5d7)

commit cd50457455a7a1af5e0bcf896ce019b891038708
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-12-25 16:19:33 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-12-25 18:39:24 +0900

    Raise proper exception when month argument is not a name

    https://bugs.ruby-lang.org/issues/17485#change-89871
    (cherry picked from commit 0867b638aff9ec192ca420a44ffa5a77c892e8f2)

commit e6e24ee502714b80723d81b3bc555a707747fda3
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-12-25 17:44:23 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-12-25 18:39:24 +0900

    Fix the names of Thread::Queue and method for the cross-reference

    (cherry picked from commit 42eb9bf37ac42cc792d619e28d153c164a5e6604)

commit fe064b130f1d146159ad43ab4df8ff9c9d2ebf32
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-12-25 17:42:27 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-12-25 18:39:24 +0900

    NEWS: Put spaces to make Method and UnboundMethod links

    (cherry picked from commit 30374b4fb77a1407e5ba8e98be03a92c4a317495)

commit 3079bffb8db6e637b7025cedf19d44a00727543c
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-12-25 17:05:39 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-12-25 18:38:58 +0900

    Add IRB Improvements section to NEWS.md

    (cherry picked from commit dba24e6a1ae0d7dba313bb5f65a4be927bd6f236)

commit 0699f310972e843232889ca8c5f12463dfaaaa48
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-12-25 15:25:41 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-12-25 15:25:41 +0900

    v3.1.0p0

commit 0abf781ab431f44c054523a3ab8f2b1c3768c898
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-12-25 13:14:54 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2021-12-25 13:14:54 +0900

    NEWS: Mention about more strict conversions for [Feature #17485]

commit 0f1fbc6421641d80a03f0b72e3d775a5f35360d0
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-12-25 12:57:51 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2021-12-25 12:57:28 +0900

    [ruby/irb] Version 1.4.1

    https://github.com/ruby/irb/commit/b1d9c34441

commit ddf0cdee4f449c2b71910357183d1ff9ed19e1ea
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-12-25 12:56:08 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2021-12-25 12:56:40 +0900

    [ruby/irb] Support showing doc by dialog in iTerm2

    https://github.com/ruby/irb/commit/a4b95d6634

commit 40c20110d5791e26e5edaddb6a77cf51c1efdede
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-12-25 00:39:43 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2021-12-25 10:58:44 +0900

    [ruby/reline] Version 0.3.0

    https://github.com/ruby/reline/commit/3f6ea92268

commit da6a5e3ed16ab0cdda7546dd9caf55c59be7b86f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-12-25 06:27:56 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2021-12-25 07:40:52 +0900

    Merge RubyGems-3.3.3 and Bundler-2.3.3

  Notes:
    Merged: https://github.com/ruby/ruby/pull/5342

commit efce9ecf72842fd2109a34a89b42933f8c841d93
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2021-12-25 03:01:01 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2021-12-25 03:31:59 +0900

    [ruby/openssl] Ruby/OpenSSL 3.0.0

    https://github.com/ruby/openssl/commit/bff4080091

commit 44bfe72892a5a07040d806c2aee89ee52955d86d
  Author:     Yusuke Nakamura <yusuke1994525@gmail.com>
  AuthorDate: 2021-12-21 17:14:30 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2021-12-25 03:31:59 +0900

    [ruby/openssl] Add test cases to OpenSSL::BN using ractor

    OpenSSL::BN has been make ractor-safed in 9e7cf9e ,
    but there was no test.
    And to use 'ractor' annotation, update test-unit to v3.4.6 or higher.

    https://github.com/ruby/openssl/commit/7541a66911

commit cab8b88a16c4fbc9c95ebebbe2774feee8f7a408
  Author:     Alan Wu <alanwu@ruby-lang.org>
  AuthorDate: 2021-12-25 02:35:24 +0900
  Commit:     Alan Wu <alanwu@ruby-lang.org>
  CommitDate: 2021-12-25 02:35:24 +0900

    NEWS: Adapt YJIT support status to include OpenBSD

    We don't run YJIT CI checks on OpenBSD so can't claim that we provide
    first-class maintenance support. However, as of
    3b2b28d035c9635b9473c7a03ede04fa6ac57a34, YJIT can at least boot on OpenBSD.

commit b81faf4b1fc0e3373596e667084e5c5d54779375
  Author:     Alan Wu <alanwu@ruby-lang.org>
  AuthorDate: 2021-12-25 01:59:57 +0900
  Commit:     Alan Wu <alanwu@ruby-lang.org>
  CommitDate: 2021-12-25 01:59:57 +0900

    Less bravado in YJIT performance claims

    YJIT can't improve performance of non Ruby software of course.

commit 90239c4163e0a9aec7add714eb5ad6e6fb246660
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-12-25 00:41:36 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2021-12-25 00:41:04 +0900

    [ruby/irb] Version 1.4.0

    https://github.com/ruby/irb/commit/b80ec5821e

commit 214b6128aebba384f62ab8d90cb63654ea5dfe28
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-12-25 00:41:15 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2021-12-25 00:41:03 +0900

    [ruby/irb] Update dependency, reline >= 0.3.0

    https://github.com/ruby/irb/commit/f36ad549c4

commit c815c0be46b83c1c5c50a88cd1452635208fbee4
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-12-24 20:07:55 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2021-12-25 00:32:58 +0900

    [ruby/reline] Escape newline(s) in dynamic prompt

    https://github.com/ruby/reline/commit/9b209ee1ea

commit b0db420b0e70753986d42579439acdd7ff0d9e95
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-12-24 20:06:48 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2021-12-25 00:32:57 +0900

    [ruby/reline] Escape newline(s) in prompt

    https://github.com/ruby/reline/commit/b545459fca

commit 22cc2243f92ef09c10534412511a02ca8ccd45cb
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-12-24 19:57:41 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2021-12-25 00:32:56 +0900

    [ruby/reline] Remove unnecessary parameter

    https://github.com/ruby/reline/commit/20fcd22564

commit 20dae14ba92c0adf1e47ab4df1a92416d27f35db
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-12-25 00:20:29 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2021-12-25 00:20:53 +0900

    Increase wait time

commit a88169bbe94f3ee767ae59a3af3038987204b21e
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-12-25 00:20:11 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2021-12-25 00:20:53 +0900

    Wait for output results to test correctly

commit 38b3adc4cb8c40bdbcd0ac8989e4ecb6c03080e9
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2021-12-25 00:01:21 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2021-12-25 00:01:21 +0900

    add a NEWS entry about cvar inline cache

commit 03c54a09ecaacb37ddc85d8ca74dc5f57b49aef1
  Author:     Yuki Nishijima <yk.nishijima@gmail.com>
  AuthorDate: 2021-12-24 23:21:41 +0900
  Commit:     Yuki Nishijima <yk.nishijima@gmail.com>
  CommitDate: 2021-12-24 23:21:55 +0900

    Revert "Revert "Replace an deprecated constant with a new one in did_you_mean""

    This reverts commit 1527f7569b0412f3bc7ac98a3461e59a4891ed96.

commit f9712b029bb6c34a2cf4131f8a54328740fd149f
  Author:     Yuki Nishijima <yk.nishijima@gmail.com>
  AuthorDate: 2021-12-24 21:04:49 +0900
  Commit:     Yuki Nishijima <yk.nishijima@gmail.com>
  CommitDate: 2021-12-24 23:20:30 +0900

    Sync did_you_mean

commit 8d940e3032055faa7271fc517c8f66ea34084542
  Author:     Soutaro Matsumoto <matsumoto@soutaro.com>
  AuthorDate: 2021-12-24 22:54:45 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2021-12-24 22:54:45 +0900

    Bundle RBS 2.0.0 (#5330)

    * Bundle RBS 2.0.0

    * Update NEWS.md

  Notes:
    Merged-By: soutaro <matsumoto@soutaro.com>

commit 0aca70e559566a9e834ae7bfcd7f8a06bfd9376b
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-12-24 22:28:57 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2021-12-24 22:29:06 +0900

    Output log after loading class to test

commit 548c8f5f7aa743ae05610ed372f857a6b488e89c
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2021-12-24 22:26:06 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2021-12-24 22:26:06 +0900

    Prefer to use RTEST when checking result of `rb_io_wait`. (#5341)

    * Prefer to use RTEST when checking result of `rb_io_wait`.

    * Consistently use false for signifying no events ready.

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit 0fbf1f193a863a2aa2d69621b530668a268e539a
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-12-24 20:55:59 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2021-12-24 20:55:59 +0900

    Add logging about timeout

commit 5138ef3875ca3ee7fc94cea536cb4f9cb50ea3fd
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-12-24 20:42:09 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2021-12-24 20:44:02 +0900

    Kill process before assertion fails

commit f279d41847e07949ca7ad3f2d3d5cbe9fa3aabf5
  Author:     manga_osyo <manga.osyo@gmail.com>
  AuthorDate: 2021-12-06 10:04:12 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2021-12-24 20:44:02 +0900

    Fix warning in `Lexer::Elem#[]`

    Changed to use `#pos` `#event` `#tok` `#state` since using Lexer::Elem#[0~4] now gives a warning.
    see: https://github.com/ruby/ruby/commit/8944009be7418614ce7d4077807ac2b60d4d5d85

    https://github.com/ruby/reline/commit/9adbb9af32

commit 67aab88a22bad23cb43058caee6fc012265aee3b
  Author:     Akinori MUSHA <knu@idaemons.org>
  AuthorDate: 2021-12-24 20:06:23 +0900
  Commit:     Akinori MUSHA <knu@idaemons.org>
  CommitDate: 2021-12-24 20:06:23 +0900

    Import digest v3.1.0 from ruby/digest

commit c87c027f18c005460746a74c07cd80ee355b16e4
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-12-21 16:31:43 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2021-12-24 19:11:10 +0900

    configure.in: unexpand exec_prefix in includedir

    Replace `exec_prefix` in includedir as well as bindir, libdir, and
    so on. [Bug #18373]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/5318

commit acfe2f2655ab25d52c4347783c4de99fa2daaf62
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2021-12-24 19:11:02 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2021-12-24 19:11:02 +0900

    Improvements to `rb_io_wait` return value handling and internal implementation. (#5340)

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit 4fccefef052fb042659fe4237d3c2d5d0446dcea
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-10-03 18:31:36 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2021-12-24 18:23:28 +0900

    [ruby/reline] Revert "Change aliased methods to be private"

    Ruby 2.5 doesn't support "private alias_method" idiom  but Ruby on Rails
    6.x still support 2.5. 😢

    This reverts commit https://github.com/ruby/reline/commit/0f075f562b9b.

    https://github.com/ruby/reline/commit/4ecaa63b26

commit fc5bc378e54bebc4ef254fa36c3736fbe2e17c43
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-10-03 15:25:25 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2021-12-24 18:23:28 +0900

    [ruby/reline] Change aliased methods to be private

    https://github.com/ruby/reline/commit/0f075f562b

commit a9c59b13da161eec3b7a1b028f83af142509d802
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-09-27 04:24:26 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2021-12-24 18:23:28 +0900

    [ruby/reline] Add doc about em-kill-line macro

    https://github.com/ruby/reline/commit/2e46493aff

commit bad1e153d485cf7b68981a78e78e23c3f118c5a8
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-09-27 04:24:06 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2021-12-24 18:23:28 +0900

    [ruby/reline] Implement em_kill_line

    https://github.com/ruby/reline/commit/9fca6ceb45

commit 6c3cc9c58ab95e963d6255d719e2248cafef7b49
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-09-27 03:58:19 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2021-12-24 18:23:28 +0900

    [ruby/reline] Rename the wrong name "em-kill-line" with the correct name "unix-line-discard"

    https://github.com/ruby/reline/commit/da7af35d1f

commit fd60a235f5feeb2fa63d8e9ebb54e2236c16ce90
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-09-27 02:32:12 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2021-12-24 18:23:28 +0900

    [ruby/reline] Add doc about ed-kill-line, kill-line, em-kill-line, and unix-line-discard

    https://github.com/ruby/reline/commit/586a48ffe0

commit 9de42d3b347a2576eba81676cab6027b3c03dda7
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-09-27 02:49:30 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2021-12-24 18:23:28 +0900

    [ruby/reline] Bind ed-kill-line to C-u on emacs mode

    https://github.com/ruby/reline/commit/9ab99574f5

commit 15fab6fb17f011dcd2661d961ac3ece1f6a88c88
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-09-19 22:24:43 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2021-12-24 18:23:28 +0900

    [ruby/reline] Support S-Tab to move up completion cursor in vi-mode on Unix

    https://github.com/ruby/reline/commit/ff278cdc88

commit 1706d1a7f3abd3ed1259607a05f0de1ee85e23c2
  Author:     Victor Shepelev <zverok.offline@gmail.com>
  AuthorDate: 2021-12-24 17:55:09 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2021-12-24 17:55:09 +0900

    [DOC] Document Marshal#load parameter freeze: (#5332)

  Notes:
    Merged-By: byroot <jean.boussier@gmail.com>

commit 35d779c57b266953a93c2f89487e913d00a40458
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-12-24 17:53:06 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2021-12-24 17:54:09 +0900

    [ruby/readline] Bump version to 0.0.3

    https://github.com/ruby/readline/commit/996af225ad

commit 106a0e519568ba821b55adc8cf4439507cdaeaac
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-12-24 17:51:33 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2021-12-24 17:53:52 +0900

    [ruby/readline-ext] Bump version to 0.1.4

    https://github.com/ruby/readline-ext/commit/6f86713b19

commit 517964d57b9340fc1e0525da56dcd567050e8537
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-10-09 23:11:38 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2021-12-24 17:33:45 +0900

    Move embedded lines outside the here document

    So that the actually run test code corresponds to the source file
    line-by-line.

commit f8a0ef30b20207aa57cce9537babcc283d8f6a4d
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-12-24 16:26:17 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2021-12-24 17:12:01 +0900

    Set time limit for waiting for terminating process within a test

  Notes:
    Merged: https://github.com/ruby/ruby/pull/5339

commit 03f16d37bfaae86efe9633843bd26c3bfb9731fb
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-12-24 17:01:24 +0900
